{$X+}

unit BigGram;

interface

uses Pol,Grammar,Editor;

const MaxLenOfId = 20;

type

PBigGrammar = ^TBigGrammar;
TBigGrammar = object(TGrammar)
                Name,
                Term,
                Neterm,
                Prav : string[MaxLenOfId];

                constructor Init;
                procedure   Reset;virtual;

                function  ReadGrammar(g:PEditor):boolean;virtual;
                function  WriteGrammar(g:PEditor):boolean;virtual;

                function  GetMemory:longint;virtual;
                function  GetNew:PGrammar;virtual;
                procedure GetCopy(g:PGrammar);virtual;

              end;

implementation

uses Common,Rule,Views,App;

constructor TBigGrammar.Init;
begin
  if not(TGrammar.Init) then Fail;
  Name:='';
  Term:='';
  Neterm:='';
  Prav:='';
end;

procedure TBigGrammar.Reset;
begin
  TGrammar.Reset;
  Name:='';
  Term:='';
  Neterm:='';
  Prav:='';
end;

function  TBigGrammar.ReadGrammar(g:PEditor):boolean;
var r,pom:string;
    o:PSym;
    p:PRuleSym;
    nold:word;
    starts:word;
    Ok,rep,Ter,Neter,rest:boolean;
    err:TError;
    n : word absolute err;

 procedure Error(m:word);
 begin
   if MemOk then begin
     Message(Application,evMyMessage,msEnd,nil);
     Message(Application,evMyMessage,m,@err);
   end;
   Ok:=false;
 end;

 procedure ReadZnak(zn:char);
 begin
   with g^ do
     if not Ok or (n>BufLen) or (BufChar(n)<>zn)
     then Ok:=false
     else begin
       inc(n);inc(err.s);
     end;
 end;

 function ReadSymbol:string;
 var r:string;
     i,x:word;
     j:shortint;
     zn:char;
 begin
   ReadSymbol:='';
   with g^ do
     if Ok and (n<=BufLen) then begin
       x:=n;
       case BufChar(n) of
         '~' : if (n+1<=BufLen) and (BufChar(n+1) in EscChars)
             then begin
               ReadSymbol:=BufChar(n+1);
               inc(n,2);inc(err.s,2);exit;
             end else Ok:=false;
         '<' : if (n+2>BufLen) or (BufChar(n+1)='>')
             then Ok:=false
             else begin
               r:='<';j:=1;i:=n+1;
               while (i<=BufLen) and (j>0) do begin
                 zn:=BufChar(i);
                 inc(i);
                 if zn>' ' then begin
                   r:=r+zn;
                   case zn of
                     '<' : inc(j);
                     '>' : dec(j);
                     '~' : if i<=BufLen then begin
                             zn:=BufChar(i);
                             if zn in ['<','>',' ',esc] then begin
                               inc(i);
                               r:=r+zn;
                             end;
                           end;
                   end;
                 end else j:=-1;
               end;
               if j=0 then n:=i else Ok:=false;
             end;
         '"' : if (n+2>BufLen) or (BufChar(n+1)='"')
             then Ok:=false
             else begin
               r:='"';j:=1;i:=n+1;
               while (i<=BufLen) and (j=1) do begin
                 zn:=BufChar(i);
                 inc(i);
                 if zn>' ' then begin
                   r:=r+zn;
                   case zn of
                     '"' : j:=0;
                     '~' : if i<=BufLen then begin
                             zn:=BufChar(i);
                             if zn in ['"',' ',esc] then begin
                               inc(i);
                               r:=r+zn;
                             end;
                           end;
                   end;
                 end else j:=-1;
               end;
               if j=0 then n:=i else Ok:=false;
             end;
         else begin
           zn:=BufChar(n);
           if EpsChar^.GetLength=1 then
             EscChars:=EscChars-[string(EpsChar^.Pol^)[1]];
           if (zn in EscChars) or (zn<=' ')
           then Ok:=false
           else begin
             r:=zn;
             inc(n);
           end;
         end;
       end;
     end else Ok:=false;

   if Ok then begin
     inc(err.s,n-x);
     if r=EpsChar^.GetStr then ReadSymbol:=epsilon
     else if r=StartSym^.GetStr then ReadSymbol:=start
     else ReadSymbol:=r;
   end;
 end;

 function  ReadIdentifikator:string;
 var r:string;
     p:word;
 begin
   p:=n;
   ReadIdentifikator:='';
   with g^ do
     if not Ok or (n>BufLen) or not(BufChar(n) in ['A'..'Z','a'..'z','_'])
     then Ok:=false
     else begin
       r:='';
       while (n<=BufLen) and (BufChar(n) in ['A'..'Z','a'..'z','_','0'..'9'])
             and (length(r)<=MaxLenOfId) do begin
         r:=r+BufChar(n);
         inc(n);
       end;
       if length(r)>MaxLenOfId then begin
         n:=p;Ok:=false;
       end else begin
         ReadIdentifikator:=r;
         inc(err.s,length(r));
       end;
     end;
 end;

 procedure ReadGr;
 begin
   with g^ do
     if (n+6>BufLen) or not Ok
         or ((BufChar(n)<>'g') and (BufChar(n)<>'G'))
         or ((BufChar(n+1)<>'r') and (BufChar(n+1)<>'R'))
         or ((BufChar(n+2)<>'a') and (BufChar(n+2)<>'A'))
         or ((BufChar(n+3)<>'m') and (BufChar(n+3)<>'M'))
         or ((BufChar(n+4)<>'m') and (BufChar(n+4)<>'M'))
         or ((BufChar(n+5)<>'a') and (BufChar(n+5)<>'A'))
         or ((BufChar(n+6)<>'r') and (BufChar(n+6)<>'R'))
     then Ok:=false
     else begin
       inc(n,7);inc(err.s,7);
     end;
 end;

 procedure ReadGramatika;
 begin
   with g^ do
     if (n+8>BufLen) or not Ok
         or ((BufChar(n)<>'g') and (BufChar(n)<>'G'))
         or ((BufChar(n+1)<>'r') and (BufChar(n+1)<>'R'))
         or ((BufChar(n+2)<>'a') and (BufChar(n+2)<>'A'))
         or ((BufChar(n+3)<>'m') and (BufChar(n+3)<>'M'))
         or ((BufChar(n+4)<>'a') and (BufChar(n+4)<>'A'))
         or ((BufChar(n+5)<>'t') and (BufChar(n+5)<>'T'))
         or ((BufChar(n+6)<>'i') and (BufChar(n+6)<>'I'))
         or ((BufChar(n+7)<>'k') and (BufChar(n+7)<>'K'))
         or ((BufChar(n+8)<>'a') and (BufChar(n+8)<>'A'))
     then Ok:=false
     else begin
       inc(n,9);inc(err.s,9);
     end;
 end;

 procedure ReadEpsilon;
 begin
   with g^ do
     if (n+6>BufLen) or not Ok
         or ((BufChar(n)<>'e') and (BufChar(n)<>'E'))
         or ((BufChar(n+1)<>'p') and (BufChar(n+1)<>'P'))
         or ((BufChar(n+2)<>'s') and (BufChar(n+2)<>'S'))
         or ((BufChar(n+3)<>'i') and (BufChar(n+3)<>'I'))
         or ((BufChar(n+4)<>'l') and (BufChar(n+4)<>'L'))
         or ((BufChar(n+5)<>'o') and (BufChar(n+5)<>'O'))
         or ((BufChar(n+6)<>'n') and (BufChar(n+6)<>'N'))
     then Ok:=false
     else begin
       inc(n,7);inc(err.s,7);
     end;
 end;

 procedure ReadMezery;
 begin
   with g^ do
     with err do begin
       if MemOk then
         repeat
           while (n<=BufLen) and (BufChar(n)<=' ') do begin
             if BufChar(n)=chr(13) then begin
               inc(r);s:=0;
               Message(Application,evMyMessage,msLine,@r);
               if r=0 then begin
                 Ok:=false;
                 Message(Application,evMyMessage,msEnd,nil);
                 exit;
               end;
             end else inc(s);
             inc(n);
           end;
           if (n<=BufLen) and (BufChar(n)='%') then begin
             inc(n);Ok:=false;
             while (n<=BufLen) and (BufChar(n)<>chr(13)) do inc(n);
           end else Ok:=true;
         until Ok;
       if (n<=BufLen) and MemOk then Ok:=true
       else begin
         Ok:=false;
         if MemOk then Error(msNeocekavanyKonec);
       end;
     end;
 end;

 procedure ReadSipka;
 begin
   with g^ do
     if (n+2<=BufLen) and Ok and
        (((BufChar(n)='-') and (BufChar(n+1)='-') and (BufChar(n+2)='>'))
        or ((BufChar(n)=':') and (BufChar(n+1)=':') and (BufChar(n+2)='=')))
     then begin
       inc(n,3);inc(err.s,3);
     end else Ok:=false;
 end;

 procedure ReadRest;
 begin
   with g^ do
     if (n+3<=BufLen) and  Ok
         and (BufChar(n) in ['r','R'])
         and (BufChar(n+1) in ['e','E'])
         and (BufChar(n+2) in ['s','S'])
         and (BufChar(n+3) in ['t','T'])
     then begin
       inc(n,4);inc(err.s,4);
     end else Ok:=false;
 end;

 procedure ReadZbytek;
 begin
   with g^ do
     if (n+5<=BufLen) and  Ok
         and (BufChar(n) in ['z','Z'])
         and (BufChar(n+1) in ['b','B'])
         and (BufChar(n+2) in ['y','Y'])
         and (BufChar(n+3) in ['t','T'])
         and (BufChar(n+4) in ['e','E'])
         and (BufChar(n+5) in ['k','K'])
     then begin
       inc(n,6);inc(err.s,6);
     end else Ok:=false;
 end;

 procedure ZbytekNeterminalu;
 begin
   rest:=false;
   ReadMezery;
   if not Ok then exit;
   ReadRest;
   if not Ok then begin
     Ok:=true;
     ReadZbytek;
     if not Ok then exit;
   end;
   rest:=true;
   ReadMezery;
   if not Ok then exit;
   ReadZnak(';');
   if not Ok then Error(msStrednik);
 end;

 function ReadTerminal:string;
 var r:string;
     p:word;
 begin
   p:=n;
   r:=ReadSymbol;
   Ok:=Ok and
       (((length(r)=1) and (r<>epsilon)) or ((length(r)>2) and(r[1]='"')));
   if Ok then ReadTerminal:=r
   else begin
     n:=p;
     ReadTerminal:='';
   end;
 end;

 function ReadNeterminal:string;
 var r:string;
     p:word;
 begin
   p:=n;
   r:=ReadSymbol;
   Ok:=Ok and
       (((length(r)=1) and (r<>epsilon)) or ((length(r)>2) and (r[1]='<')));
   if Ok then ReadNeterminal:=r
   else begin
     n:=p;
     ReadNeterminal:='';
   end;
 end;

{####################### Hlavicka ###########################}

  procedure CtiHlavicku;
  begin
    ReadMezery;
    if not Ok then exit;
    ReadGr;
    if not Ok then begin
      Ok:=true;
      ReadGramatika;
      if not Ok then begin
        Error(msGrammar);exit;
      end;
    end;
    ReadMezery;
    if not Ok then exit;
    r:=ReadIdentifikator;
    if not Ok then begin
      Error(msIdentifikator);exit;
    end;
    Name:=r;
    ReadMezery;
    if not Ok then exit;
    ReadZnak('(');
    if not Ok then begin
      Error(msLevaKulataZavorka);exit;
    end;
    ReadMezery;
    if not Ok then exit;
    r:=ReadIdentifikator;
    if not Ok then begin
      Error(msIdentifikator);exit;
    end;
    Neterm:=r;
    ReadMezery;
    if not Ok then exit;
    ReadZnak(',');
    if not Ok then begin
      Error(msCarka);exit;
    end;
    ReadMezery;
    if not Ok then exit;
    r:=ReadIdentifikator;
    if not Ok then begin
      Error(msIdentifikator);exit;
    end;
    Term:=r;
    ReadMezery;
    if not Ok then exit;
    ReadZnak(',');
    if not Ok then begin
      Error(msCarka);exit;
    end;
    ReadMezery;
    if not Ok then exit;
    r:=ReadIdentifikator;
    if not Ok then begin
      Error(msIdentifikator);exit;
    end;
    Prav:=r;
    ReadMezery;
    if not Ok then exit;
    ReadZnak(',');
    if not Ok then begin
      Error(msCarka);exit;
    end;
    ReadMezery;
    if not Ok then exit;
    StartS:=n;
    r:=ReadNeterminal;
    if not Ok then begin
      n:=StartS;
      Error(msNeterminal);exit;
    end;
    StartSym:=Sym(r);
    if r[1]='<' then Neterminal^.AddItem(1,Sym(start));
    ReadMezery;
    if not Ok then exit;
    ReadZnak(')');
    if not Ok then begin
      Error(msPravaKulataZavorka);exit;
    end;
    ReadMezery;
    if not Ok then exit;
    ReadZnak(';');
    if not Ok then Error(msStrednik);
  end;


{########################## Epsilon ##########################}

  procedure CtiEpsilon;
  begin
    ReadMezery;
    if not Ok then exit;
    ReadEpsilon;
    if not Ok then begin
      Ok:=true;EpsChar:=Sym('e');exit;
    end;
    ReadMezery;
    if not Ok then exit;
    ReadZnak('=');
    if not Ok then begin
      Error(msRovnitko);exit
    end;
    ReadMezery;
    if not Ok then exit;
    nold:=n;
    r:=ReadSymbol;
    if not Ok then begin
      Error(msSymbol);exit
    end;
    EpsChar:=Sym(r);
    if StartSym=EpsChar then begin
        n:=nold;Error(msEpsilon);exit
    end;
    ReadMezery;
    if not Ok then exit;
    ReadZnak(';');
    if not Ok then Error(msStrednik);
  end;


{########################## Terminaly ############################}

  procedure CtiTerminaly;
  var b,next:boolean;
      rr:string;
      i:byte;
  begin
    ReadMezery;
    if not Ok then exit;
    ReadZnak('=');
    if not Ok then begin
      Error(msRovnitko);exit
    end;
    ReadMezery;
    if not Ok then exit;
    ReadZnak('{');
    if not Ok then begin
      Error(msLevaSlozZavorka);exit
    end;
    b:=true;next:=false;
    ReadMezery;
    if not Ok then exit;
    ReadZnak('}');
    if not Ok then begin
      Ok:=true;
      repeat
        ReadMezery;
        if not Ok then exit;
        nold:=n;
        r:=ReadTerminal;
        o:=Sym(r);
        if not Ok or (not rest and Neter and Neterminal^.IsInside(o))
        then begin
          n:=nold;
          Error(msTerminal);exit
        end;
        Terminal^.AddSym(o);
        if next then begin
          if length(r)<>1 then begin
            Error(msSpatnyInterval);exit end;
          for i:=ord(rr[1])+1 to ord(r[1])-1 do begin
            o:=Sym(chr(i));
            if not rest and Neter and Neterminal^.IsInside(o) then begin
              Error(msMeziterminal);exit
            end;
            Terminal^.AddSym(o);
          end;
        end;
        ReadMezery;
        if not Ok then exit;
        ReadZnak(',');
        if not Ok then begin
          Ok:=true;
          ReadZnak('.');
          if not Ok then begin
            Ok:=true;
            ReadZnak('}');
            if not Ok then begin Error(msPravaSlozZavorka);exit end;
            b:=false;
          end else begin
            if next or (length(r)<>1) then begin
              Error(msSpatnyInterval);exit
            end;
            ReadZnak('.');
            if not Ok then begin Error(msTecka);exit end;
            next:=true;rr:=r;
          end;
        end else next:=false;
      until not b;
    end;
    ReadMezery;
    if not Ok then exit;
    ReadZnak(';');
    if not Ok then Error(msStrednik);
  end;


{################################ Neterminaly ###################}

  procedure CtiNeterminaly;
  var b:boolean;
  begin
    ReadMezery;
    if not Ok then exit;
    ReadZnak('=');
    if not Ok then begin
      Error(msRovnitko);exit
    end;
    ZbytekNeterminalu;
    if Ok then exit else Ok:=true;
    ReadMezery;
    if not Ok then exit;
    ReadZnak('{');
    if not Ok then begin
      Error(msLevaSlozZavorka);exit
    end;
    b:=true;
    repeat
      ReadMezery;
      if not Ok then exit;
      nold:=n;
      r:=ReadNeterminal;
      o:=Sym(r);
      if not Ok or (Ter and Terminal^.IsInside(o)) then begin
        n:=nold;
        Error(msNeterminal);exit
      end;
      Neterminal^.AddSym(o);
      ReadMezery;
      if not Ok then exit;
      ReadZnak(',');
      if not Ok then begin
        Ok:=true;
        ReadZnak('}');
        if not Ok then begin Error(msPravaSlozZavorka);exit end;
        b:=false;
      end;
    until not(b);
    ReadMezery;
    if not Ok then exit;
    ReadZnak(';');
    if not Ok then Error(msStrednik);
  end;


{############################ Pravidla #########################}

  procedure CtiPravidla;
  var b:boolean;
      g:PSym;

    procedure ReadPravidlo;
    var b:boolean;
    begin
      p^.InitSetStr;
      ReadMezery;
      if not Ok then exit;
      if not rep then begin
        nold:=n;
        r:=ReadNeterminal;
        o:=Sym(r);
        if rest or (length(r)>2) then Neterminal^.AddSym(o);
        if not Ok
           or Terminal^.IsInside(o) or (r=epsilon)
           or not Neterminal^.IsInside(o)
        then begin
          n:=nold;
          Error(msNeterminal);exit
        end;
        p^.SetStr(o);
        g:=o;
        ReadMezery;
        if not Ok then exit;
        ReadSipka;
        if not Ok then begin Error(msSipka);exit end;
        ReadMezery;
        if not Ok then exit;
      end else p^.SetStr(g);
      nold:=n;
      r:=ReadSymbol;
      o:=Sym(r);
      if Ok then begin
        if length(r)>2 then
          case r[1] of
            '<' : Neterminal^.AddSym(o);
            '"' : Terminal^.AddSym(o);
          end
        else if not Terminal^.IsInside(o) and (r<>epsilon) then
          if rest then Neterminal^.AddSym(o)
          else if not Neterminal^.IsInside(o) then begin
            n:=nold;
            Error(msSymbol);exit;
          end;
      end else begin
        Error(msSymbol);exit;
      end;
      if r=epsilon then b:=false
                   else b:=true;
      p^.SetStr(o);
      while b do begin
        ReadMezery;
        if not Ok then exit;
        nold:=n;
        r:=ReadSymbol;
        o:=Sym(r);
        if Ok then begin
          if length(r)>2 then
            case r[1] of
              '<' : Neterminal^.AddSym(o);
              '"' : Terminal^.AddSym(o);
            end
          else if not Terminal^.IsInside(o) then
            if rest and (r<>epsilon) then Neterminal^.AddSym(o)
            else if not Neterminal^.IsInside(o) then begin
              n:=nold;
              Error(msSymbol);exit;
            end;
          p^.SetStr(o);
        end else begin
          b:=false;
          Ok:=true;
        end;
      end;
    end;


{####################### Telo pravidel ########################}

  begin
    ReadMezery;
    if not Ok then exit;
    nold:=n;
    r:=ReadIdentifikator;
    if not Ok or (r<>Prav) then begin
      n:=nold;
      Error(msIdPrav);exit
    end;
    ReadMezery;
    if not Ok then exit;
    ReadZnak('=');
    if not Ok then begin
      Error(msRovnitko);exit
    end;
    ReadMezery;
    if not Ok then exit;
    ReadZnak('{');
    if not Ok then begin
      Error(msLevaSlozZavorka);exit
    end;
    b:=true;
    rep:=false;
    repeat
      ReadPravidlo;
      if not Ok then exit;
      with Pravidla^ do 
        if not IsInside(p) then AddItem(Num+1,p);
      ReadMezery;
      if not Ok then exit;
      ReadZnak(',');
      if not Ok then begin
        Ok:=true;
        ReadZnak('|');
        if Ok then rep:=true
        else begin
          Ok:=true;
          ReadZnak('}');
          if not Ok then begin Error(msPravaSlozZavorka);exit end;
          b:=false;
        end;
      end else rep:=false;
    until not(b);
    ReadMezery;
    if not Ok then exit;
    ReadZnak('.');
    if not Ok then Error(msTecka);
  end;


{#################### Cti Symboly ###################################}


  procedure CtiSymboly;
  begin
    repeat
      ReadMezery;
      if not Ok then exit;
      nold:=n;
      r:=ReadIdentifikator;
      if not Ok then begin
        if Neter then Error(MsIdTerm)
        else Error(MsIdNeterm);
        exit;
      end else begin
        if (r=Neterm) and not Neter then begin
          CtiNeterminaly;
          Neter:=true;
        end else if (r=Term) and not Ter then begin
          CtiTerminaly;
          Ter:=true;
        end else begin
          n:=nold;
          if Neter then Error(MsIdTerm)
          else Error(MsIdNeterm);
          exit;
        end;
      end;
    until Ter and Neter or not Ok;
  end;


{##################### Telo ReadGrammar ########################}


begin
  ReadGrammar:=false;
  Reset;
  new(p,Init);if p=nil then exit;
  Message(Application,evMyMessage,msStart,nil);
  EpsChar:=Sym('');n:=0;Ter:=false;Neter:=false;
  with err do begin
    r:=1;s:=1;
  end;
  if g^.BufLen>0 then Ok:=true
                 else Ok:=false;
  if Ok then CtiHlavicku;
  if Ok then CtiEpsilon;
  if Ok and (EpsChar^.GetLength=1) then
    EscChars:=EscChars+[string(EpsChar^.Pol^)[1]];
  if Ok and (StartSym=EpsChar) then begin
    n:=Starts;Error(msNeterminal);
  end;
  if Ok then CtiSymboly;
  if Ok then begin
    o:=Sym(start);
    if rest then Neterminal^.AddSym(o)
    else if not Neterminal^.IsInside(o) then begin
      n:=Starts;Error(msNeterminal);
    end;
  end;
  if Ok then CtiPravidla;
  dispose(p,Done);
  ReadGrammar:=Ok;
  if Ok then begin
    Message(Application,evMyMessage,msEnd,nil);
    TestStates;
  end;
end;

function  TBigGrammar.WriteGrammar(g:PEditor):boolean;
const CR = chr(13);
var r,s:string;
    Ok:boolean;
    i:integer;

  function  WriteSymbol(s:string):string;
  begin
    if s=epsilon then WriteSymbol:=EpsChar^.GetStr
    else if s=start then WriteSymbol:=StartSym^.GetStr
    else if (length(s)=1) and (s[1] in EscChars)
    then WriteSymbol:=esc+s[1]
    else WriteSymbol:=s;
  end;

  procedure Save(var r:string;s:string);
  begin
    if Ok then
      if (length(s)<=MaxLine-length(r)) and (s<>'') then r:=r+s
      else begin
        r:=r+CR;
        Ok:=g^.InsertText(@r[1],length(r),false);
        WriteGrammar:=Ok;
        r:=s;
      end;
  end;

begin
  if EpsChar^.GetLength=1 then EscChars:=EscChars+[string(EpsChar^.Pol^)[1]];
  WriteGrammar:=false;Ok:=true;
  r:='gramatika ';s:=Name;Save(r,s);Save(r,'(');
  s:=Neterm;Save(r,s);Save(r,',');
  s:=Term;Save(r,s);Save(r,',');
  s:=Prav;Save(r,s);Save(r,',');
  s:=WriteSymbol(start);Save(r,s);
  Save(r,');');Save(r,'');Save(r,'');
  if not Ok then exit;
  if EpsChar^.GetStr<>'e' then begin
    r:='epsilon = ';s:=EpsChar^.GetStr;Save(r,s);
    Save(r,';');Save(r,'');Save(r,'');
    if not Ok then exit;
  end;
  r:=Neterm;Save(r,' = {');
  with Neterminal^ do
    for i:=1 to Num do begin
      s:=WriteSymbol(GetItem(i)^.GetStr);
      if Ok then Save(r,s);
      if i<>Num then Save(r,',');
    end;
  Save(r,'};');Save(r,'');Save(r,'');
  if not Ok then exit;
  r:=Term;Save(r,' = {');
  with Terminal^ do
    for i:=1 to Num do begin
      s:=WriteSymbol(GetItem(i)^.GetStr);
      if Ok then Save(r,s);
      if i<>Num then Save(r,',');
    end;
  Save(r,'};');Save(r,'');Save(r,'');
  if not Ok then exit;
  r:=Prav;Save(r,' = {');
  with Pravidla^ do
    for i:=1 to GetNum do
      with GetItem(i)^ do begin
        InitGetStr;
        s:=WriteSymbol(GetStr);
        Save(r,s);Save(r,' --> ');
        s:=WriteSymbol(GetStr);
        while Ok and (s<>'') do begin
          Save(r,s);s:=WriteSymbol(GetStr);
        end;
        if i<>GetNum then begin
          Save(r,',');Save(r,'');Save(r,'     ');
        end;
      end;
  Save(r,'}.');Save(r,'');
end;

function  TBigGrammar.GetMemory:longint;
begin
  GetMemory:=TGrammar.GetMemory+SizeOf(Name)+SizeOf(Term)+
             SizeOf(Neterm)+SizeOf(Prav);
end;

function  TBigGrammar.GetNew:PGrammar;
begin
  GetNew:=new(PBigGrammar,Init);
end;

procedure TBigGrammar.GetCopy(g:PGrammar);
begin
  if g<>nil then begin
    TGrammar.GetCopy(g);
    PBigGrammar(g)^.Name:=Name;
    PBigGrammar(g)^.Term:=Term;
    PBigGrammar(g)^.Neterm:=Neterm;
    PBigGrammar(g)^.Prav:=Prav;
  end;
end;

end.