unit DemoChom;

interface

{$X+}

uses Objects, Drivers, Views, Tracer, Pol, ListSet, Rule, Grammar, MyTracer;

type

  PDemoChom = ^TDemoChom;
  TDemoChom = object(TAlgWindow)
    Terminal,
    Neterminal,
    Pravidla, pom     : PSet;
    StartSym, EpsChar : PSym;
    sq, sq1           : PRuleSym;
    q, q1             : PRule;
    r                 : string;
    s, w              : PSym;
    j                 : word;
    b,zobraz          : boolean;
    ProperList        : PPropertyList;

    constructor Init(g:PGrammar;ANumber:integer);
    destructor Done;virtual;
    procedure Close;virtual;

    procedure DoStep(key:word);virtual;
    procedure DisposeDyn(p:pointer);virtual;
    procedure CopyDyn(Source,Target:pointer);virtual;
    procedure ChangeBounds(var Bounds:TRect);virtual;
    function  GetProperStep(st:word):integer;virtual;
    function  GetNumOfLines(st:word):byte;virtual;
  end;

implementation

uses Crt, Common, Dialogs, App, MyApp;

const cmNewRule  = 200;
      cmShowRule = 201;

type

  PDataChomskeho = ^TDataChomskeho;
  TDataChomskeho = record
    Gramatika         : PGrammar;
    NRule,
    NNet : PSet;
    prav : PRule;
    zprac: PRuleSym;
    i,n  : word;
  end;

  PView1Chomskeho = ^TView1Chomskeho;
  TView1Chomskeho = object(TAlgView)
    procedure Draw;virtual;
  end;

  PView2Chomskeho = ^TView2Chomskeho;
  TView2Chomskeho = object(TAlgView)
    procedure Draw;virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
  end;

  PViewAktPrav = ^TViewAktPrav;
  TViewAktPrav = object(TAlgView)
    procedure Draw;virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
  end;

  PViewTerminal = ^TViewTerminal;
  TViewTerminal = object(TAlgView)
    procedure Draw;virtual;
  end;


constructor TDemoChom.Init(g:PGrammar;ANumber:integer);
var Re:TRect;
    P:PView;
    L:PAlgTextCol;
    D:TDataChomskeho;

begin
  Re.Assign(0,0,80,23);
  TAlgWindow.Init(Re,'Transformace do Chomskho NF',ANumber,
                        MaxNumOfBackSteps,0,SizeOf(TDataChomskeho),g);

  new(pom,Init);
  new(sq,Init);
  q:=PRule(sq^.Pol);
  new(sq1,Init);
  q1:=PRule(sq1^.Pol);
  with q^ do begin
    AddItem(1,Sym(''));
    AddItem(2,Sym(''));
  end;
  q1^.AddItem(1,Sym(''));
  new(ProperList,Init);

  Terminal:=g^.Terminal;
  Neterminal:=g^.Neterminal;
  Pravidla:=g^.Pravidla;
  StartSym:=g^.StartSym;
  EpsChar:=g^.EpsChar;

  zobraz:=false;
  with D do begin
    Gramatika:=g;
    NNet:=pom;
    NRule:=pom;
    prav:=nil;
    zprac:=nil;
    i:=1;
    n:=1;
  end;
  SetData(D);

  Re.Grow(-1,-1);
  Re.A.Y:=Re.B.Y-5;
  P:=new(PAlgText,Init(Re));
  L:=new(PAlgTextCol,Init(20,1));
  with L^ do begin
    AtInsert( 0,NewStr('1. Nech je na vstupu vlastn gramatika bez jednoduchch pravidel'));
    AtInsert( 1,NewStr('2. Pokud existuje pravidlo, kter jet nebylo zpracovno, pejdeme na krok 3,'));
    AtInsert( 2,NewStr('   jinak pejdeme na krok 7'));
    AtInsert( 3,NewStr('3. Vezmme jet nezpracovan pravidlo pvodn gramatiky'));
    AtInsert( 4,NewStr('4. M-li toto pravidlo tvar A --> a, kde A je neterminl a a je terminl,'));
    AtInsert( 5,NewStr('   nebo m pravidlo tvar S --> e, kde S je startovac symbol a e je epsilon,'));
    AtInsert( 6,NewStr('   potom toto pravidlo pidme do nov gramatiky a pejdeme na krok 2'));
    AtInsert( 7,NewStr('5. M-li pravidlo tvar A --> bc, kde b,c je terminl nebo neterminl,'));
    AtInsert( 8,NewStr('   pak do nov gramatiky pidme pravidlo A --> <b''><c''>, kde <b''>,<c''> jsou'));
    AtInsert( 9,NewStr('   neterminly, kter nahrazuj terminly b,c, a pejdeme na krok 2'));
    AtInsert(10,NewStr('6. Jinak m pravidlo tvar A --> <X1>...<Xk>, kde k>2 a <X1>...<Xk> jsou'));
    AtInsert(11,NewStr('   terminly nebo neterminly. Potom do nov gramatiky pidme pravidla,'));
    AtInsert(12,NewStr('   kter maj tento tvar:             A --> <X1''> <<X2>...<Xk>>'));
    AtInsert(13,NewStr('                          <<X2>...<Xk>> --> <X2''> <<X3>...<Xk>>'));
    AtInsert(14,NewStr('                             :                :'));
    AtInsert(15,NewStr('                          <<Xk-1><Xk>>  --> <Xk-1''> <Xk''>'));
    AtInsert(16,NewStr('   kde <Xi''> je neterminl nahrazujc terminl <Xi>, a pejdeme na krok 2'));
    AtInsert(17,NewStr('7. Pro kad nov neterminl <X''>, kter vznikl nahrazenm terminlu X,'));
    AtInsert(18,NewStr('   pak pidme do nov gramatiky pravidlo <X''> --> X'));
    AtInsert(19,NewStr('8. Nyn je nov gramatika v Chomskho normln form'));
  end;
  SetLastStep(19);
  PAlgText(P)^.NewList(L);
  InsertSubView(0,P);
  Re.Assign(1,1,29,17);
  P:=new(PView1Chomskeho,Init(Re,nil,nil));
  InsertSubView(1,P);
  Re.Assign(50,1,79,17);
  P:=new(PView2Chomskeho,Init(Re,nil,nil));
  InsertSubView(2,P);
  Re.Assign(30,1,49,4);
  P:=new(PViewStartSym,Init(Re,nil,nil));
  InsertSubView(3,P);
  Re.Assign(30,4,49,7);
  P:=new(PViewAktPrav,Init(Re,nil,nil));
  InsertSubView(4,P);
  Re.Assign(30,7,49,17);
  P:=new(PViewTerminal,Init(Re,nil,nil));
  InsertSubView(5,P);
end;

destructor TDemoChom.Done;
begin
  if ProperList<>nil then dispose(ProperList,Done);
  with PDataChomskeho(DP)^ do
    if Gramatika<>nil then dispose(Gramatika,Done);
  if pom<>nil then dispose(pom,Done);
  if sq<>nil then dispose(sq,Done);
  if sq1<>nil then dispose(sq1,Done);
  TAlgWindow.Done;
end;

procedure TDemoChom.Close;
var k:PSet;
begin
  Message(Application,evBroadcast,cmBusy,nil);
  with PDataChomskeho(DP)^ do
    if Step=19 then begin
      if NNet<>nil then NNet^.Sjednoceni(Gramatika^.Neterminal);
      k:=Gramatika^.Pravidla;
      Gramatika^.Pravidla:=NRule;
      NRule:=k;
      Gramatika^.SetState(_jeChomskeho_);
      Gramatika^.ZrusNadbytecnaPravidla;
      Message(Application,evCommand,cmWriteGrammar,Gramatika);
    end;
  TAlgWindow.Close;
end;

procedure TDemoChom.DoStep(key:word);
begin
  with PDataChomskeho(DP)^ do
    case Step of
       0 : NS(1);
       1 : if n>Pravidla^.Num then NS(2) else NS(3);
       2 : NS(17);
       3 : begin
             prav:=PRule(Pravidla^.GetItem(n)^.Pol);
             Message(@Self,evBroadcast,cmShowRule,nil);
             NS(4);
           end;
       4 : begin
             prav:=PRule(Pravidla^.GetItem(n)^.Pol);
             if (prav^.Num=1) and Terminal^.IsInside(prav^.GetItem(1))
             then NS(6) else NS(5);
           end;
       5 : begin
             prav:=PRule(Pravidla^.GetItem(n)^.Pol);
             if (prav^.Num=1) and (PSym(prav^.GetItem(1))=Sym(epsilon))
             then NS(6) else NS(7);
           end;
       6 : begin
             prav:=PRule(Pravidla^.GetItem(n)^.Pol);
             NRule^.AddItem(NRule^.Num+1,Pravidla^.GetItem(n));
             Message(@Self,evBroadcast,cmNewRule,nil);
             prav:=nil;
             inc(n);
             NSM(1);
           end;
       7 : begin
             prav:=PRule(Pravidla^.GetItem(n)^.Pol);
             if prav^.Num=2 then NS(8) else NS(10);
           end;
       8 : begin
             zprac:=PRuleSym(Pravidla^.GetItem(n)^.GetNewCopy);
             prav:=PRule(zprac^.Pol);
             if not Neterminal^.IsInside(prav^.GetItem(1))
             then prav^.SetItem(1,ProperList^.GetNewSym(PSym(prav^.GetItem(1)),
             Neterminal,StartSym,EpsChar));
             if not Neterminal^.IsInside(prav^.GetItem(2))
             then prav^.SetItem(2,ProperList^.GetNewSym(PSym(prav^.GetItem(2)),
             Neterminal,StartSym,EpsChar));
             Message(@Self,evBroadcast,cmShowRule,nil);
             NRule^.MoveItem(NRule^.Num+1,zprac);
             Message(@Self,evBroadcast,cmNewRule,nil);
             zprac:=nil;
             prav:=nil;
             inc(n);
             NSM(9);
           end;
       9 : NS(1);
      10 : begin
             prav:=PRule(Pravidla^.GetItem(n)^.Pol);
             NS(11);
           end;
      11 : begin
             prav:=PRule(Pravidla^.GetItem(n)^.Pol);
             NS(12);
           end;
      12 : begin
             zprac:=PRuleSym(Pravidla^.GetItem(n)^.GetNewCopy);
             prav:=PRule(zprac^.Pol);
             if not Neterminal^.IsInside(prav^.GetItem(1))
             then prav^.SetItem(1,ProperList^.GetNewSym(PSym(prav^.GetItem(1)),
             Neterminal,StartSym,EpsChar));
             r:='';j:=2;
             while j<=prav^.Num do begin
               if PSym(prav^.GetItem(j))=Sym(start)
               then r:=r+StartSym^.GetStr
               else r:=r+prav^.GetItem(j)^.GetStr;
               inc(j);
             end;
             s:=ProperList^.GetNewSym(Sym(r),Neterminal,StartSym,EpsChar);
             q^.Head:=prav^.Head;
             q^.SetItem(1,prav^.GetItem(1));
             q^.SetItem(2,s);
             j:=NRule^.GetPosSym(1,sq);
             if j>0 then NRule^.DelItem(j);
             NRule^.AddItem(NRule^.Num+1,sq);
             Message(@Self,evBroadcast,cmNewRule,nil);
             prav^.Head:=s;
             prav^.DelItem(1);
             Message(@Self,evBroadcast,cmShowRule,nil);
             NSM(13);
           end;
      13 : begin
             prav:=PRule(zprac^.Pol);
             if prav^.Num=2 then NS(15) else begin
               if not Neterminal^.IsInside(prav^.GetItem(1))
               then prav^.SetItem(1,ProperList^.GetNewSym(PSym(prav^.GetItem(1)),
               Neterminal,StartSym,EpsChar));
               r:='';j:=2;
               while j<=prav^.Num do begin
                 if PSym(prav^.GetItem(j))=Sym(start)
                 then r:=r+StartSym^.GetStr
                 else r:=r+prav^.GetItem(j)^.GetStr;
                 inc(j);
               end;
               s:=ProperList^.GetNewSym(Sym(r),Neterminal,StartSym,EpsChar);
               q^.Head:=prav^.Head;
               q^.SetItem(1,prav^.GetItem(1));
               q^.SetItem(2,s);
               j:=NRule^.GetPosSym(1,sq);
               if j>0 then NRule^.DelItem(j);
               NRule^.AddItem(NRule^.Num+1,sq);
               Message(@Self,evBroadcast,cmNewRule,nil);
               prav^.Head:=s;
               prav^.DelItem(1);
               Message(@Self,evBroadcast,cmShowRule,nil);
               NSM(14);
             end;
           end;
      14 : begin
             prav:=PRule(zprac^.Pol);
             if prav^.Num=2 then NS(15) else begin
               while prav^.Num>2 do begin
                 if not Neterminal^.IsInside(prav^.GetItem(1))
                 then prav^.SetItem(1,ProperList^.GetNewSym(PSym(prav^.GetItem(1)),
                 Neterminal,StartSym,EpsChar));
                 r:='';j:=2;
                 while j<=prav^.Num do begin
                   if PSym(prav^.GetItem(j))=Sym(start)
                   then r:=r+StartSym^.GetStr
                   else r:=r+prav^.GetItem(j)^.GetStr;
                   inc(j);
                 end;
                 s:=ProperList^.GetNewSym(Sym(r),Neterminal,StartSym,EpsChar);
                 q^.Head:=prav^.Head;
                 q^.SetItem(1,prav^.GetItem(1));
                 q^.SetItem(2,s);
                 j:=NRule^.GetPosSym(1,sq);
                 if j>0 then NRule^.DelItem(j);
                 NRule^.AddItem(NRule^.Num+1,sq);
                 Message(@Self,evBroadcast,cmNewRule,nil);
                 prav^.Head:=s;
                 prav^.DelItem(1);
                 Message(@Self,evBroadcast,cmShowRule,nil);
               end;
               NSM(15);
             end;
           end;
      15 : begin
             prav:=PRule(zprac^.Pol);
             if not Neterminal^.IsInside(prav^.GetItem(1))
             then prav^.SetItem(1,ProperList^.GetNewSym(PSym(prav^.GetItem(1)),
             Neterminal,StartSym,EpsChar));
             if not Neterminal^.IsInside(prav^.GetItem(2))
             then prav^.SetItem(2,ProperList^.GetNewSym(PSym(prav^.GetItem(2)),
             Neterminal,StartSym,EpsChar));
             Message(@Self,evBroadcast,cmShowRule,nil);
             j:=NRule^.GetPosSym(1,zprac);
             if j>0 then NRule^.DelItem(j);
             NRule^.MoveItem(NRule^.Num+1,zprac);
             Message(@Self,evBroadcast,cmNewRule,nil);
             zprac:=nil;
             inc(n);
             NSM(16);
           end;
      16 : NS(1);
      17 : begin
             s:=ProperList^.GetOldNet(i);
             b:=false;
             prav:=nil;
             while (s<>nil) and not Terminal^.IsInside(s) do begin
               NNet^.AddSym(ProperList^.GetNewNet(i));
               inc(i);
               b:=true;
               s:=ProperList^.GetOldNet(i);
             end;
             if s=nil then
               if b then NSM(19)
               else NS(19)
             else if b then NSM(18)
                  else NS(18);
           end;
      18 : begin
             s:=ProperList^.GetOldNet(i);
             w:=ProperList^.GetNewNet(i);
             if w<>nil then begin
               NNet^.AddSym(w);
               if Terminal^.IsInside(s) then begin
                 q1^.Head:=w;
                 q1^.SetItem(1,s);
                 NRule^.AddItem(NRule^.Num+1,sq1);
                 Message(@Self,evBroadcast,cmNewRule,nil);
               end;
             end;
             inc(i);
             NSM(17);
           end;
      19 : ;
    end;
  TAlgWindow.DoStep(key);
end;

procedure TDemoChom.DisposeDyn(p:pointer);
begin
  with PDataChomskeho(p)^ do begin
    if NRule<>nil then dispose(NRule,Done);
    if NNet<>nil then dispose(NNet,Done);
    if zprac<>nil then dispose(zprac,Done);
  end;
end;

procedure TDemoChom.CopyDyn(Source,Target:pointer);
begin
  with PDataChomskeho(Source)^ do begin
    if NRule<>nil then
      PDataChomskeho(Target)^.NRule:=PSet(NRule^.GetNewCopy);
    if NNet<>nil then
      PDataChomskeho(Target)^.NNet:=PSet(NNet^.GetNewCopy);
    if zprac<>nil then
      PDataChomskeho(Target)^.zprac:=PRuleSym(zprac^.GetNewCopy);
  end;
end;

procedure TDemoChom.ChangeBounds(var Bounds:TRect);
var Re:TRect;
    p,x,y:integer;
begin
  Lock;
  x:=Bounds.B.X-Bounds.A.X;
  y:=Bounds.B.Y-Bounds.A.Y;
  p:=y*2 div 3+2;
  if y-p<3 then
    if y<7 then p:=y-2
    else p:=y-3;
  Re.Assign(1,p,x-1,y-1);
  GetSubView(0)^.ChangeBounds(Re);
  y:=p;
  p:=x div 3 + 3;
  if p>x div 2-1 then p:=x div 2-1;
  Re.Assign(1,1,p,y);
  GetSubView(1)^.ChangeBounds(Re);
  Re.Assign(x-p-1,1,x-1,y);
  GetSubView(2)^.ChangeBounds(Re);
  if (x-2*p-3>5) and (y>=7) then zobraz:=true;
  if (x-2*p-3<5) or (y<7) then zobraz:=false;
  Re.Assign(p+1,1,x-p-2,4);
  with GetSubView(3)^ do begin
    if zobraz then begin
      ChangeBounds(Re);
      Show;
    end else Hide;
  end;
  Re.Assign(p+1,4,x-p-2,7);
  with GetSubView(4)^ do begin
    if zobraz then begin
      ChangeBounds(Re);
      Show;
    end else Hide;
  end;
  Re.Assign(p+1,7,x-p-2,y);
  with GetSubView(5)^ do begin
    if zobraz and (y>9) then begin
      ChangeBounds(Re);
      Show;
    end else Hide;
  end;
  TAlgWin.ChangeBounds(Bounds);
  Unlock;
end;

function  TDemoChom.GetProperStep(st:word):integer;
const a:array[1..8] of byte = (0,1,3,4,7,10,17,19);
begin
  if (st<1) or (st>8) then GetProperStep:=-1
  else GetProperStep:=a[st];
end;

function  TDemoChom.GetNumOfLines(st:word):byte;
const a:array[1..8] of byte = (1,2,1,3,3,7,2,1);
begin
  if (st<1) or (st>8) then GetNumOfLines:=0
  else GetNumOfLines:=a[st];
end;

procedure TView1Chomskeho.Draw;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;
    Frame('Pvodn gramatika',0);
  end;

  with PDataChomskeho(DP)^ do
    with Gramatika^ do
      if Down then
        if Step=1 then
          Ukaz(Pravidla,n,GetColor(2) or 128)
        else
          if Step in [3..5,7,10..15] then
            Ukaz(Pravidla,n,GetColor(2))
          else
            Ukaz(Pravidla,0,0)
      else
        if Step=3 then
          Ukaz(Pravidla,n,GetColor(2) or 128)
        else
          if Step in [4..8,10..16] then
            Ukaz(Pravidla,n,GetColor(2))
          else
            Ukaz(Pravidla,0,0);
end;

procedure TView2Chomskeho.Draw;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;
    Frame('Nov gramatika',0);
  end;

  with PDataChomskeho(DP)^ do
    with Gramatika^ do
      if Down then
        if Step in [6,8,12..15,18] then
          Ukaz(NRule,NRule^.Num,GetColor(2) or 128)
        else
          Ukaz(NRule,0,0)
      else
        if (Step in [1,9,13,14,16,17]) and
           ((Step<>1) or (n<=Pravidla^.Num)) and
           ((Step<>17) or (i>1)) then begin
          Ukaz(NRule,NRule^.Num,GetColor(2) or 128);
          Wait(300);
        end else
          Ukaz(NRule,0,0);
end;

procedure TView2Chomskeho.HandleEvent(var Event:TEvent);
begin
  TAlgView.HandleEvent(Event);
  if Event.Command=cmNewRule then begin
    DrawView;
    Wait(250);
    ClearEvent(Event);
  end;
end;

procedure TViewAktPrav.Draw;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;

    Frame('Akt. pravidlo',1);
  end;

  with PDataChomskeho(DP)^ do
    with Gramatika^ do
      if Down then
        if prav<>nil then
          WP(prav,1,1,GetColor(3))
        else WS('',1,1,Color)
      else
        if Step in [4..8,10..16] then
          WP(PRule(Pravidla^.GetItem(n)^.Pol),1,1,GetColor(3))
        else WS('',1,1,Color);
end;

procedure TViewAktPrav.HandleEvent(var Event:TEvent);
begin
  TAlgView.HandleEvent(Event);
  if Event.Command=cmShowRule then begin
    DrawView;
    ClearEvent(Event);
  end;
end;

procedure TViewTerminal.Draw;
var m:word;
    l:byte;
    r,s:string;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;

    Frame('Terminly',1);
    with PDataChomskeho(DP)^ do
      UkazSym(Gramatika^.Terminal,0,0);
  end;
end;

end.