unit DemoGrei;

interface

{$X+}

uses Objects, Drivers, Tracer, Pol, ListSet, Rule, Grammar, MyTracer;

type

  PDemoGrei = ^TDemoGrei;
  TDemoGrei = object(TAlgWindow)
    Terminal,
    Neterminal,
    Pravidla,
    SetOfNr,
    Nr, zrus, pom     : PSet;
    StartSym, EpsChar : PSym;
    s, h              : PSym;
    n                 : word;
    zobraz, b         : boolean;
    ProperList        : PPropertyList;
    r, r1             : PRule;
    q, q1             : PRuleSym;
    pp                : PItem;

    constructor Init(g:PGrammar;ANumber:integer);
    destructor Done;virtual;
    procedure Close;virtual;

    procedure DoStep(key:word);virtual;
    procedure DisposeDyn(p:pointer);virtual;
    procedure CopyDyn(Source,Target:pointer);virtual;
    procedure ChangeBounds(var Bounds:TRect);virtual;
    function  GetProperStep(st:word):integer;virtual;
    function  GetNumOfLines(st:word):byte;virtual;
  end;

implementation

uses Crt, Common, Dialogs, Views, App, MyApp;

const cmNewRule2a = 220;
      cmNewRule2b = 221;

type

  PDataGrei = ^TDataGrei;
  TDataGrei = record
    Gramatika : PGrammar;
    PomPrav,
    NNet : PSet;
    i,j  : word;
  end;

  PView1Grei = ^TView1Grei;
  TView1Grei = object(TAlgView)
    procedure Draw;virtual;
  end;

  PView2Grei = ^TView2Grei;
  TView2Grei = object(TAlgView)
    blikej:boolean;
    pozice:word;
    constructor Init(var Bounds: TRect;AHScrollBar,AVScrollBar: PScrollBar);
    procedure Draw;virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
  end;

  PViewNeterminal = ^TViewNeterminal;
  TViewNeterminal = object(TAlgView)
    procedure Draw;virtual;
  end;

  PViewProm = ^TViewProm;
  TViewProm = object(TAlgView)
    procedure Draw;virtual;
  end;

constructor TDemoGrei.Init(g:PGrammar;ANumber:integer);
var Re:TRect;
    P:PView;
    L:PAlgTextCol;
    D:TDataGrei;

begin
  Re.Assign(0,0,80,23);
  TAlgWindow.Init(Re,'Transformace do Greibachovy NF',ANumber,
               MaxNumOfBackSteps,0,SizeOf(TDataGrei),g);

  new(pom,Init);
  new(ProperList,Init);
  new(SetOfNr,Init);
  new(Zrus,Init);

  new(q1,Init);
  r:=PRule(q1^.Pol);
  r^.AddItem(1,Sym(''));

  Terminal:=g^.Terminal;
  Neterminal:=g^.Neterminal;
  Pravidla:=g^.Pravidla;
  StartSym:=g^.StartSym;
  EpsChar:=g^.EpsChar;

  zobraz:=false;
  q:=nil;
  p:=nil;
  r:=nil;
  r1:=nil;
  n:=0;

  with D do begin
    Gramatika:=g;
    NNet:=g^.Neterminal;
    PomPrav:=pom;
    i:=0;
    j:=1;
  end;
  SetData(D);

  Re.Grow(-1,-1);
  Re.A.Y:=Re.B.Y-5;
  P:=new(PAlgText,Init(Re));
  L:=new(PAlgTextCol,Init(15,1));
  with L^ do begin
    AtInsert( 0,NewStr('1.  Nech je na vstupu vlastn gramatika bez lev rekurze'));
    AtInsert( 1,NewStr('2.  Nejprve uspodme mnoinu neterminl tak, aby platilo, e kad'));
    AtInsert( 2,NewStr('    A-pravidlo zan bu terminlem, a nebo neterminlem B takovm, e A<B'));
    AtInsert( 3,NewStr('3.  Polome i:=n, kde n je poet neterminl'));
    AtInsert( 4,NewStr('4.  Kdy i=0, pejdeme na krok 7'));
    AtInsert( 5,NewStr('5.  Jinak v nov gramatice nahradme kad pravidlo tvaru Ai --> Aj, kde j>i,'));
    AtInsert( 6,NewStr('    pravidly Ai --> 1 | ... | m, kde Aj --> 1 | ... | m jsou Aj-pravidla'));
    AtInsert( 7,NewStr('    Vechna zbvajc pravidla ponechme v nov gramatice beze zmn'));
    AtInsert( 8,NewStr('6.  Pak polome i:=i-1 a pejdeme na krok 4'));
    AtInsert( 9,NewStr('7.  Nyn vechna pravidla zanaj terminlem (mimo pravidla S --> e)'));
    AtInsert(10,NewStr('8.  V kadm pravidle A --> a<X1>...<Xk> nahradme vechny terminly <Xi>'));
    AtInsert(11,NewStr('    novmi neterminlnmi symboly <Xi''>'));
    AtInsert(12,NewStr('9.  Pro kad nov neterminl <X''>, kter vznikl nahrazenm terminlu X,'));
    AtInsert(13,NewStr('    pak pidme do nov gramatiky pravidlo <X''> --> X'));
    AtInsert(14,NewStr('10. Nyn je nov gramatika v Greibachov normln form'));
  end;
  SetLastStep(14);
  PAlgText(P)^.NewList(L);
  InsertSubView(0,P);
  Re.Assign(1,1,29,17);
  P:=new(PView1Grei,Init(Re,nil,nil));
  InsertSubView(1,P);
  Re.Assign(50,1,79,17);
  P:=new(PView2Grei,Init(Re,nil,nil));
  InsertSubView(2,P);
  Re.Assign(30,1,49,4);
  P:=new(PViewStartSym,Init(Re,nil,nil));
  InsertSubView(3,P);
  Re.Assign(30,4,49,5);
  P:=new(PViewProm,Init(Re,nil,nil));
  InsertSubView(4,P);
  Re.Assign(30,5,49,17);
  P:=new(PViewNeterminal,Init(Re,nil,nil));
  InsertSubView(5,P);
end;

destructor TDemoGrei.Done;
begin
  if ProperList<>nil then dispose(ProperList,Done);
  with PDataGrei(DP)^ do
    if Gramatika<>nil then dispose(Gramatika,Done);
  if pom<>nil then dispose(pom,Done);
  if Zrus<>nil then dispose(Zrus,Done);
  if SetOfNr<>nil then dispose(SetOfNr,Done);
  if q1<>nil then dispose(q1,Done);
  TAlgWindow.Done;
end;

procedure TDemoGrei.Close;
var k:PSet;
begin
  Message(Application,evBroadcast,cmBusy,nil);
  with PDataGrei(DP)^ do
    if Step=14 then begin
      if NNet<>nil then NNet^.Sjednoceni(Gramatika^.Neterminal);
      k:=Gramatika^.Pravidla;
      Gramatika^.Pravidla:=PomPrav;
      PomPrav:=k;
      Gramatika^.SetState(_jeGreibachova_);
      Gramatika^.ZrusNadbytecnaPravidla;
      Message(Application,evCommand,cmWriteGrammar,Gramatika);
    end;
  TAlgWindow.Close;
end;

procedure TDemoGrei.DoStep(key:word);

 procedure Nahrad(pr:PRuleSym);
 var q:PRuleSym;
     s:PSym;
     n,m:word;
 begin
   if pr=nil then exit;
   with PDataGrei(DP)^ do begin
     n:=1;m:=0;
     s:=PSym(PRule(pr^.Pol)^.RemoveItem(1));
     while (n<=PomPrav^.Num-m) and MemOk do begin
       if s=PRule(PomPrav^.GetItem(n)^.Pol)^.Head then begin
         Message(@Self,evBroadcast,cmNewRule2b,pointer(n));
         q:=PRuleSym(pr^.GetNewCopy);
         if q<>nil then begin
           PRule(q^.Pol)^.Insert(1,PRule(PomPrav^.GetItem(n)^.Pol));
           PomPrav^.MoveItem(PomPrav^.Num+1,q);
           Message(@Self,evBroadcast,cmNewRule2a,pointer(PomPrav^.Num));
           inc(m);
         end;
       end;
       inc(n);
     end;
     dispose(pr,Done);
   end;
 end;

begin
  with PDataGrei(DP)^ do
    case Step of
      0 : NS(1);
      1 : NS(2);
      2 : begin
            n:=1;
            while (n<=Neterminal^.Num) and MemOk do begin   {pro kazdy neterminal}
              Nr:=Gramatika^.Mnozina_Nr(PSym(Neterminal^.GetItem(n))); {vytvor mn neterminalu < x}
              if Nr<>nil then begin
                new(r,Init);                                       {do pravidla r}
                if r<>nil then begin
                  pp:=Nr^.List;                      {dej jako extRule tu mnozinu}
                  Nr^.List:=r^.List;
                  with r^ do begin
                    List:=pp;
                    Num:=Nr^.Num;
                    Head:=PSym(Neterminal^.GetItem(n));
                    Pos:=1;
                    Akt:=List;
                  end;
                  new(q,Init);
                  if q<>nil then begin
                    r1:=q^.Pol;
                    q^.Pol:=r;
                    SetOfNr^.MoveSym(q);
                    dispose(r1,Done);
                  end else dispose(r,Done);
                end;
                dispose(Nr,Done);                {a smaz vnitrek prazdne mn.}
              end;
              inc(n);
            end;
            {konec priprav na usporadani - nastavena SetOfNr}

            while (SetOfNr^.Num>0) and MemOk do begin  {pro vsechny neterminaly}
              n:=SetOfNr^.Num;
              repeat
                while (n>0) and
                      (PRule(SetOfNr^.GetItem(n)^.Pol)^.Num<>0) do {najdi nejvetsi neterminal}
                  dec(n);                          {vzdy exituje - leva rekuze}
                if n>0 then begin
                  s:=PRule(SetOfNr^.GetItem(n)^.Pol)^.Head;
                  with NNet^ do begin
                    h:=PSym(RemoveItem(GetPosSym(1,s)));
                    AddItem(1,h);
                  end;
                  Zrus^.AddSym(s);
                  SetOfNr^.DelItem(n);
                  dec(n);
                end;
              until n<=0;
              n:=1;pp:=SetOfNr^.List;
              while (n<=SetOfNr^.Num) and MemOk do begin {aktual. nej. neterminaly}
                Zrus^.Rozdil(PRule(pp^.Item^.Pol));
                inc(n);
                pp:=pp^.next;
              end;
              Zrus^.Reset;
            end;
            {konec usporadavani pravidel a prevodu do castecne GNF}
            NSM(3);
          end;
      3 : begin
            i:=NNet^.Num;
            j:=1;
            NSM(4);
          end;
      4 : if i=0 then NS(9) else NS(5);
      5 : begin
            while (j<=Pravidla^.Num) and MemOk and
              (PRule(Pravidla^.GetItem(j)^.Pol)^.Head<>PSym(NNet^.GetItem(i)))
            do inc(j);
            if (j<=Pravidla^.Num) and MemOk then begin
              Message(@Self,evBroadcast,cmNewRule2a,pointer(0));
              if NNet^.IsInside(PRule(Pravidla^.GetItem(j)^.Pol)^.List^.Item)
              then NSM(6)
              else NSM(7);
            end else NS(8);
          end;
      6 : begin
            q:=PRuleSym(Pravidla^.GetItem(j));
            Nahrad(PRuleSym(q^.GetNewCopy));
            inc(j);
            NSM(5);
          end;
      7 : begin
            q:=PRuleSym(Pravidla^.GetItem(j));
            PomPrav^.AddItem(PomPrav^.Num+1,q);
            Message(@Self,evBroadcast,cmNewRule2a,pointer(PomPrav^.Num));
            inc(j);
            NSM(5);
          end;
      8 : begin
            dec(i);
            j:=1;
            NSM(4);
          end;
      9 : NS(10);
     10 : if (j<=PomPrav^.Num) and MemOk
          then NS(11)
          else begin
            j:=0;
            NSM(12);
          end;
     11 : begin
            n:=2;
            r:=PRule(PomPrav^.GetItem(j)^.Pol);
            pp:=r^.List^.next;
            while (n<=r^.Num) and MemOk do begin
              if Terminal^.IsInside(pp^.Item) then
                pp^.Item:=ProperList^.GetNewSym(PSym(pp^.Item),Neterminal,StartSym,EpsChar);
              inc(n);
              pp:=pp^.next;
            end;
            Message(@Self,evBroadcast,cmNewRule2b,pointer(j));
            Message(@Self,evBroadcast,cmNewRule2a,pointer(0));
            inc(j);
            NSM(10);
          end;
          {konec transformace pravidel do GNF}
     12 : if ProperList^.GetOldNet(j+1)=nil then NS(14) else NS(13);
     13 : begin
            inc(j);
            s:=ProperList^.GetOldNet(j);
            h:=ProperList^.GetNewNet(j);
            r:=PRule(q1^.Pol);
            if h<>nil then begin
              NNet^.AddSym(h);
              if Terminal^.IsInside(s) then begin
                r^.Head:=h;
                r^.SetItem(1,s);
                PomPrav^.AddItem(PomPrav^.Num+1,q1);
                Message(@Self,evBroadcast,cmNewRule2a,pointer(PomPrav^.Num));
                Wait(500);
              end;
            end;
            NSM(12);
          end;
     14 : ;
    end;
  TAlgWindow.DoStep(key);
end;

procedure TDemoGrei.DisposeDyn(p:pointer);
begin
  with PDataGrei(p)^ do begin
    if PomPrav<>nil then dispose(PomPrav,Done);
    if NNet<>nil then dispose(NNet,Done);
  end;
end;

procedure TDemoGrei.CopyDyn(Source,Target:pointer);
begin
  with PDataGrei(Source)^ do begin
    if PomPrav<>nil then
      PDataGrei(Target)^.PomPrav:=PSet(PomPrav^.GetNewCopy);
    if NNet<>nil then
      PDataGrei(Target)^.NNet:=PSet(NNet^.GetNewCopy);
  end;
end;

procedure TDemoGrei.ChangeBounds(var Bounds:TRect);
var Re:TRect;
    p,x,yy:integer;
begin
  Lock;
  x:=Bounds.B.X-Bounds.A.X;
  yy:=Bounds.B.Y-Bounds.A.Y;
  p:=yy*2 div 3+2;
  if yy-p<3 then
    if yy<7 then p:=yy-2
    else p:=yy-3;
  Re.Assign(1,p,x-1,yy-1);
  GetSubView(0)^.ChangeBounds(Re);
  yy:=p;
  p:=x div 3 + 3;
  if p>x div 2-1 then p:=x div 2-1;
  Re.Assign(1,1,p,yy);
  GetSubView(1)^.ChangeBounds(Re);
  Re.Assign(x-p-1,1,x-1,yy);
  GetSubView(2)^.ChangeBounds(Re);
  if (x-2*p-3>5) and (yy>=5) then zobraz:=true;
  if (x-2*p-3<5) or (yy<5) then zobraz:=false;
  Re.Assign(p+1,1,x-p-2,4);
  with GetSubView(3)^ do begin
    if zobraz then begin
      ChangeBounds(Re);
      Show;
    end else Hide;
  end;
  Re.Assign(p+1,4,x-p-2,5);
  with GetSubView(4)^ do begin
    if zobraz then begin
      ChangeBounds(Re);
      Show;
    end else Hide;
  end;
  Re.Assign(p+1,5,x-p-2,yy);
  with GetSubView(5)^ do begin
    if zobraz and (yy>7) then begin
      ChangeBounds(Re);
      Show;
    end else Hide;
  end;
  TAlgWin.ChangeBounds(Bounds);
  Unlock;
end;

function  TDemoGrei.GetProperStep(st:word):integer;
const a:array[1..10] of byte = (0,1,3,4,5,8,9,10,12,14);
begin
  if (st<1) or (st>10) then GetProperStep:=-1
  else GetProperStep:=a[st];
end;

function  TDemoGrei.GetNumOfLines(st:word):byte;
const a:array[1..10] of byte = (1,2,1,1,3,1,1,2,2,1);
begin
  if (st<1) or (st>10) then GetNumOfLines:=0
  else GetNumOfLines:=a[st];
end;

procedure TView1Grei.Draw;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;
    Frame('Pvodn gramatika',0);
  end;

  with PDataGrei(DP)^ do
    with Gramatika^ do
      if Down then
        if (Step in [0..4,6..14]) or (Step=5) and (j>Pravidla^.Num) then
          Ukaz(Pravidla,0,0)
        else
          Ukaz(Pravidla,j,GetColor(2))
      else
        if (Step=6) or (Step=7) then
          Ukaz(Pravidla,j,GetColor(2))
        else
          Ukaz(Pravidla,0,0);
end;

constructor TView2Grei.Init(var Bounds:TRect;AHScrollBar,AVScrollBar:PScrollBar);
begin
  TAlgView.Init(Bounds,AHScrollBar,AVScrollBar);
  blikej:=false;
  pozice:=0;
end;

procedure TView2Grei.Draw;
var p:byte;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;
    Frame('Nov gramatika',0);
  end;

  if blikej then p:=128 else p:=0;
  with PDataGrei(DP)^ do
    if Down then
      if Step in [6,7,13] then
        Ukaz(PomPrav,pozice,GetColor(2) or p)
      else
        if (Step=11) or (Step=10) and (j<=PomPrav^.Num) then
          Ukaz(PomPrav,j,GetColor(2) or p)
        else
          Ukaz(PomPrav,0,0)
    else
      if (Step=5) and (j>1) or (Step=12) and (j>0) then
        Ukaz(PomPrav,PomPrav^.Num,GetColor(2))
      else
        if (Step=11) or (Step=10) and (j>1) then
          Ukaz(PomPrav,j,GetColor(2))
        else
          Ukaz(PomPrav,0,0);
end;

procedure TView2Grei.HandleEvent(var Event:TEvent);
begin
  TAlgView.HandleEvent(Event);
  if Event.What=evBroadCast then begin
    case Event.Command of
      cmNewRule2a : begin
          blikej:=false;
          pozice:=Event.InfoWord;
          DrawView;
          if pozice<>0 then Wait(500);
        end;
      cmNewRule2b : begin
          blikej:=true;
          pozice:=Event.InfoWord;
          DrawView;
          if Pozice<>0 then Wait(500);
        end;
      else exit;
    end;
    ClearEvent(Event);
  end;
end;

procedure TViewNeterminal.Draw;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;

    Frame('Neterminly',1);
  end;

  with PDataGrei(DP)^ do
    UkazSym(NNet,i,GetColor(2));
end;

procedure TViewProm.Draw;
var s:string;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;
  end;

  with PDataGrei(DP)^ do begin
    str(i,s);
    if Size.X-6>=length(s) then
      WS(' i = '+s,0,0,Color)
    else
      WS(s,0,0,Color);
  end;
end;

end.