unit DemoJedn;

interface

{$X+}

uses Objects, Drivers, Tracer, Pol, ListSet, Rule, Grammar, MyTracer;

type

  PDemoJedn = ^TDemoJedn;
  TDemoJedn = object(TAlgWindow)
    Terminal,
    Neterminal,
    Pravidla, pom     : PSet;
    StartSym, EpsChar : PSym;
    zobraz, b         : boolean;
    s                 : PSym;
    q1                : PRuleSym;

    constructor Init(g:PGrammar;ANumber:integer);
    destructor Done;virtual;
    procedure Close;virtual;

    procedure DoStep(key:word);virtual;
    procedure DisposeDyn(p:pointer);virtual;
    procedure CopyDyn(Source,Target:pointer);virtual;
    procedure ChangeBounds(var Bounds:TRect);virtual;
    function  GetProperStep(st:word):integer;virtual;
    function  GetNumOfLines(st:word):byte;virtual;
  end;

implementation

uses Crt, Common, Dialogs, Views, App, MyApp;

const cmShowRule1 = 230;
      cmShowRule2 = 231;
      cmShowNet   = 232;
type

  PDataJedn = ^TDataJedn;
  TDataJedn = record
    Gramatika : PGrammar;
    PomPrav,
    N0, Ni : PSet;
    i,j,m,n: word;
  end;

  PView1Jedn = ^TView1Jedn;
  TView1Jedn = object(TAlgView)
    pozice:word;
    constructor Init(var Bounds:TRect;AHScrollBar,AVScrollBar:PScrollBar);
    procedure Draw;virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
  end;

  PView2Jedn = ^TView2Jedn;
  TView2Jedn = object(TAlgView)
    pozice:word;
    constructor Init(var Bounds:TRect;AHScrollBar,AVScrollBar:PScrollBar);
    procedure Draw;virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
  end;

  PViewNeterminal = ^TViewNeterminal;
  TViewNeterminal = object(TAlgView)
    procedure Draw;virtual;
  end;

  PViewN0 = ^TViewN0;
  TViewN0 = object(TAlgView)
    procedure Draw;virtual;
  end;

  PViewNi = ^TViewNi;
  TViewNi = object(TAlgView)
    pozice:word;
    constructor Init(var Bounds:TRect;AHScrollBar,AVScrollBar:PScrollBar);
    procedure Draw;virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
  end;

  PViewProm = ^TViewProm;
  TViewProm = object(TAlgView)
    procedure Draw;virtual;
  end;

constructor TDemoJedn.Init(g:PGrammar;ANumber:integer);
var Re:TRect;
    P:PView;
    L:PAlgTextCol;
    D:TDataJedn;

begin
  Re.Assign(0,0,80,23);
  TAlgWindow.Init(Re,'Transformace na gr. bez jednoduchch pravidel',ANumber,
               MaxNumOfBackSteps,0,SizeOf(TDataJedn),g);

  new(pom,Init);

  Terminal:=g^.Terminal;
  Neterminal:=g^.Neterminal;
  Pravidla:=g^.Pravidla;
  StartSym:=g^.StartSym;
  EpsChar:=g^.EpsChar;

  zobraz:=false;

  with D do begin
    Gramatika:=g;
    PomPrav:=pom;
    N0:=pom;
    Ni:=pom;
    i:=0;
    j:=0;
    n:=0;
    m:=0;
  end;
  SetData(D);

  Re.Grow(-1,-1);
  Re.A.Y:=Re.B.Y-5;
  P:=new(PAlgText,Init(Re));
  L:=new(PAlgTextCol,Init(11,1));
  with L^ do begin
    AtInsert( 0,NewStr('1. Nech je na vstupu gramatika bez epsilonovch pravidel'));
    AtInsert( 1,NewStr('2. Pro kad neterminl A vytvome mnoinu N(A) = {B | A =>* B} takto:'));
    AtInsert( 2,NewStr('3. Polome No:={A} a i:=1'));
    AtInsert( 3,NewStr('4. Pak Ni:={C | B --> C je pravidlo z P a B  Ni-1} sjednoceno s Ni-1'));
    AtInsert( 4,NewStr('5. Kdy plat, e Ni<>Ni-1, potom i:=i+1 a pejdeme na krok 4,'));
    AtInsert( 5,NewStr('   jinak N(A):=Ni a pejdeme na krok 6'));
    AtInsert( 6,NewStr('6. Do nov gramatiky pesuneme vechna A-pravidla, krom jednoduchch,'));
    AtInsert( 7,NewStr('   a pro kad neterminal B  N(A) a pravidlo B --> , kter nen jednoduch,'));
    AtInsert( 8,NewStr('   pidme navc pravidlo A --> '));
    AtInsert( 9,NewStr('7. Pokud jsme jet neproli vechny neterminly, pejdeme na krok 2,'));
    AtInsert(10,NewStr('   jinak je nov gramatika bez jednouduchch pravidel'));
  end;
  SetLastStep(10);
  PAlgText(P)^.NewList(L);
  InsertSubView(0,P);
  Re.Assign(1,1,29,17);
  P:=new(PView1Jedn,Init(Re,nil,nil));
  InsertSubView(1,P);
  Re.Assign(50,1,79,17);
  P:=new(PView2Jedn,Init(Re,nil,nil));
  InsertSubView(2,P);
  Re.Assign(30,1,49,4);
  P:=new(PViewNeterminal,Init(Re,nil,nil));
  InsertSubView(3,P);
  Re.Assign(30,4,49,5);
  P:=new(PViewProm,Init(Re,nil,nil));
  InsertSubView(4,P);
  Re.Assign(30,5,49,11);
  P:=new(PViewNi,Init(Re,nil,nil));
  InsertSubView(5,P);
  Re.Assign(30,11,49,17);
  P:=new(PViewN0,Init(Re,nil,nil));
  InsertSubView(6,P);
end;

destructor TDemoJedn.Done;
begin
  with PDataJedn(DP)^ do
    if Gramatika<>nil then dispose(Gramatika,Done);
  if pom<>nil then dispose(pom,Done);
  TAlgWindow.Done;
end;

procedure TDemoJedn.Close;
var k:PSet;
begin
  Message(Application,evBroadcast,cmBusy,nil);
  with PDataJedn(DP)^ do
    if Step=10 then
      with Gramatika^ do begin
        k:=Pravidla;
        Pravidla:=PomPrav;
        PomPrav:=k;
        SetState(_jeJednoducha_);
        if PlatiZe(_jeRedukovana_) then ZrusNadbytecnaPravidla;
        Message(Application,evCommand,cmWriteGrammar,Gramatika);
      end;
  TAlgWindow.Close;
end;

procedure TDemoJedn.DoStep(key:word);
var p1:PSet;
begin
  with PDataJedn(DP)^ do
    case Step of
      0 : begin
            j:=1;
            NSM(1);
          end;
      1 : NS(2);
      2 : begin
            i:=1;
            N0^.AddItem(1,Neterminal^.GetItem(j));
            NSM(3);
          end;
      3 : begin
            n:=1;
            while (n<=Pravidla^.Num) and MemOk do begin
              with PRule(Pravidla^.GetItem(n)^.Pol)^ do
                if (Num=1) and N0^.IsInside(Head) and
                   Neterminal^.IsInside(List^.Item)
                then begin
		  Message(@Self,evBroadcast,cmShowRule1,pointer(n));
	          Wait(200);
		  Ni^.AddItem(Ni^.Num+1,List^.Item);
                  Message(@Self,evBroadcast,cmShowNet,pointer(Ni^.Num));
		  Wait(500);
                end;
              inc(n);
            end;
            N0^.Sjednoceni(Ni);
            NSM(4);
          end;
      4 : if N0^.IsEqual(Ni) or not MemOk then NS(5) else begin
            N0^.Reset;
            p1:=N0;N0:=Ni;Ni:=p1;
            inc(i);
            NSM(3);
          end;
      5 : begin
            N0^.Reset;
            i:=0;
            NSM(6);
          end;
      6 : begin
            n:=1;
            s:=PSym(Neterminal^.GetItem(j));
            while (n<=Pravidla^.Num) and MemOk do begin
              q1:=PRuleSym(Pravidla^.GetItem(n));
              with PRule(q1^.Pol)^ do
                if (s=Head) and 
                   ((Num>1) or not Neterminal^.IsInside(List^.Item))
                then begin
                  Message(@Self,evBroadcast,cmShowRule1,pointer(n));
                  Wait(200);
                  PomPrav^.AddItem(PomPrav^.Num+1,q1);
                  Message(@Self,evBroadcast,cmShowRule2,pointer(PomPrav^.Num));
                  Wait(500);
                end;                 
              inc(n);
            end;
            n:=1;
            m:=0;
	    NSM(7);
          end;
      7 : begin
            b:=true;
            s:=PSym(Neterminal^.GetItem(j));
            while (n<=Pravidla^.Num) and b and MemOk do
              with PRule(Pravidla^.GetItem(n)^.Pol)^ do
                if (Head<>s) and Ni^.IsInside(Head) and
                   ((Num>1) or not Neterminal^.IsInside(List^.Item))
                then begin
                  b:=false;
                  m:=Ni^.GetPosSym(1,Head);
                end else inc(n);
            if (n<=Pravidla^.Num) and MemOk then NSM(8)
            else begin
              Ni^.Reset;
              inc(j);
              n:=0;
              m:=0;
              NSM(9);
            end;
          end;
      8 : begin
            q1:=PRuleSym(Pravidla^.GetItem(n));
            with PRule(q1^.Pol)^ do begin
              s:=Head;
              Head:=PSym(Neterminal^.GetItem(j));
              PomPrav^.AddItem(PomPrav^.Num+1,q1);
              Head:=s;
            end;
            inc(n);
            NSM(7);
          end;
      9 : if (j<=Neterminal^.Num) and MemOk then NS(1) else NS(10);
     10 : ;
    end;
  TAlgWindow.DoStep(key);
end;

procedure TDemoJedn.DisposeDyn(p:pointer);
begin
  with PDataJedn(p)^ do begin
    if PomPrav<>nil then dispose(PomPrav,Done);
    if N0<>nil then dispose(N0,Done);
    if Ni<>nil then dispose(Ni,Done);
  end;
end;

procedure TDemoJedn.CopyDyn(Source,Target:pointer);
begin
  with PDataJedn(Source)^ do begin
    if PomPrav<>nil then
      PDataJedn(Target)^.PomPrav:=PSet(PomPrav^.GetNewCopy);
    if N0<>nil then
      PDataJedn(Target)^.N0:=PSet(N0^.GetNewCopy);
    if Ni<>nil then
      PDataJedn(Target)^.Ni:=PSet(Ni^.GetNewCopy);
  end;
end;

procedure TDemoJedn.ChangeBounds(var Bounds:TRect);
var Re:TRect;
    p,q,x,yy:integer;
begin
  Lock;
  x:=Bounds.B.X-Bounds.A.X;
  yy:=Bounds.B.Y-Bounds.A.Y;
  p:=yy*2 div 3+2;
  if yy-p<3 then
    if yy<7 then p:=yy-2
    else p:=yy-3;
  Re.Assign(1,p,x-1,yy-1);
  GetSubView(0)^.ChangeBounds(Re);
  yy:=p;
  p:=x div 3 + 3;
  if p>x div 2-1 then p:=x div 2-1;
  Re.Assign(1,1,p,yy);
  GetSubView(1)^.ChangeBounds(Re);
  Re.Assign(x-p-1,1,x-1,yy);
  GetSubView(2)^.ChangeBounds(Re);
  if (x-2*p-3>5) and (yy>=7) then zobraz:=true;
  if (x-2*p-3<5) or (yy<7) then zobraz:=false;
  q:=1;
  Re.Assign(p+1,1,x-p-2,4);
  with GetSubView(3)^ do begin
    if zobraz and (yy>10) then begin
      ChangeBounds(Re);
      Show;
      inc(q,3);
    end else Hide;
  end;
  Re.Assign(p+1,q,x-p-2,q+1);
  with GetSubView(4)^ do begin
    if zobraz and (yy>7) then begin
      ChangeBounds(Re);
      Show;
      inc(q);
    end else Hide;
  end;
  Re.Assign(p+1,q,x-p-2,(yy-q+1) div 2+q);
  with GetSubView(5)^ do begin
    if zobraz then begin
      ChangeBounds(Re);
      Show;
    end else Hide;
  end;
  Re.Assign(p+1,(yy-q+1) div 2+q,x-p-2,yy);
  with GetSubView(6)^ do begin
    if zobraz then begin
      ChangeBounds(Re);
      Show;
    end else Hide;
  end;
  TAlgWin.ChangeBounds(Bounds);
  Unlock;
end;

function  TDemoJedn.GetProperStep(st:word):integer;
const a:array[1..7] of byte = (0,1,2,3,4,6,9);
begin
  if (st<1) or (st>7) then GetProperStep:=-1
  else GetProperStep:=a[st];
end;

function  TDemoJedn.GetNumOfLines(st:word):byte;
const a:array[1..7] of byte = (1,1,1,1,2,3,2);
begin
  if (st<1) or (st>7) then GetNumOfLines:=0
  else GetNumOfLines:=a[st];
end;

constructor TView1Jedn.Init(var Bounds:TRect;AHScrollBar,AVScrollBar:PScrollBar);
begin
  TAlgView.Init(Bounds,AHScrollBar,AVScrollBar);
  pozice:=0;
end;

procedure TView1Jedn.Draw;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;
    Frame('Pvodn gramatika',0);
  end;

  with PDataJedn(DP)^ do
   with Gramatika^ do
    if Down then
      if Step in [3,6] then Ukaz(Pravidla,pozice,GetColor(2))
      else if Step=7 then
         Ukaz(Pravidla,n,GetColor(2))
      else Ukaz(Pravidla,0,0)
    else if Step in [8,9] then Ukaz(Pravidla,n,GetColor(2))
      else Ukaz(Pravidla,0,0);
end;

procedure TView1Jedn.HandleEvent(var Event:TEvent);
begin
  TAlgView.HandleEvent(Event);
  if (Event.What=evBroadcast) and (Event.Command=cmShowRule1) then begin
    pozice:=Event.InfoWord;
    DrawView;
    pozice:=0;
    ClearEvent(Event);
  end;
end;

constructor TView2Jedn.Init(var Bounds:TRect;AHScrollBar,AVScrollBar:PScrollBar);
begin
  TAlgView.Init(Bounds,AHScrollBar,AVScrollBar);
  pozice:=0;
end;

procedure TView2Jedn.Draw;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;
    Frame('Nov gramatika',0);
  end;

  with PDataJedn(DP)^ do
    with PomPrav^ do
      if Down then
        if Step=8 then
          Ukaz(PomPrav,Num,GetColor(2))
        else if Step=6 then
          Ukaz(PomPrav,pozice,GetColor(2))
        else
          Ukaz(PomPrav,0,0)
      else
        if (Step=7) and (n>1) then
          Ukaz(PomPrav,Num,GetColor(2))
        else
          Ukaz(PomPrav,0,0);
end;

procedure TView2Jedn.HandleEvent(var Event:TEvent);
begin
  TAlgView.HandleEvent(Event);
  if (Event.What=evBroadCast) and (Event.Command=cmShowRule2) then begin
    pozice:=Event.InfoWord;
    DrawView;
    pozice:=0;
    ClearEvent(Event);
  end;
end;

procedure TViewNeterminal.Draw;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;

    Frame('Neterminly',1);
  end;

  with PDataJedn(DP)^ do
    with Gramatika^ do
     UkazSym(Neterminal,j,GetColor(2));
end;

procedure TViewN0.Draw;
var s:string;
begin
  with PDataJedn(DP)^ do begin
    if First then begin
      Color:=GetColor(1);
      TAlgScroller.Draw;

      if i>0 then begin
        str(i-1,s);
        s:='Mnoina N'+s;
      end else s:='';
      Frame(s,1);
    end else
      if Step in [2,4,5] then begin
      if i>0 then begin
        str(i-1,s);
        s:='Mnoina N'+s;
      end else s:='';
      Frame(s,1);
    end;
    UkazSym(N0,0,0);
  end;
end;

constructor TViewNi.Init(var Bounds:TRect;AHScrollBar,AVScrollBar:PScrollBar);
begin
  TAlgView.Init(Bounds,AHScrollBar,AVScrollBar);
  pozice:=0;
end;

procedure TViewNi.Draw;
var s:string;
begin
  with PDataJedn(DP)^ do begin
    if First then begin
      Color:=GetColor(1);
      TAlgScroller.Draw;

      if i>0 then str(i,s) else s:='(A)';
      s:='Mnoina N'+s;
      Frame(s,1);
    end else if Step in [2,4,5] then begin
      if i>0 then str(i,s) else s:='(A)';
      s:='Mnoina N'+s;
      Frame(s,1);
    end;
    if Down then
      if Step=3 then UkazSym(Ni,pozice,GetColor(2))
      else if Step in [7,8] then UkazSym(Ni,m,GetColor(2))
      else UkazSym(Ni,0,0)
    else if Step in [7,8,9] then UkazSym(Ni,m,GetColor(2))
      else UkazSym(Ni,0,0);
  end;
end;
 
procedure TViewNi.HandleEvent(var Event:TEvent);
begin
  TAlgView.HandleEvent(Event);
  if (Event.What=evBroadcast) and (Event.Command=cmShowNet) then begin
    pozice:=Event.InfoWord;
    DrawView;
    pozice:=0;
    ClearEvent(Event);
  end;
end;

procedure TViewProm.Draw;
var s:string;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;
  end;

  with PDataJedn(DP)^ do begin
    str(i,s);
    if Size.X-6>=length(s) then
      WS(' i = '+s,0,0,Color)
    else
      WS(s,0,0,Color);
  end;
end;

end.