unit DemoRec;

interface

{$X+}

uses Objects, Drivers, Tracer, Pol, ListSet, Rule, Grammar, MyTracer;

type

  PDemoRec = ^TDemoRec;
  TDemoRec = object(TAlgWindow)
    Terminal,
    Neterminal,
    Pravidla, pom     : PSet;
    StartSym, EpsChar : PSym;
    s, h              : PSym;
    y                 : word;
    b,zobraz          : boolean;
    ProperList        : PPropertyList;
    prav              : PRule;
    zprac             : PRuleSym;

    constructor Init(g:PGrammar;ANumber:integer);
    destructor Done;virtual;
    procedure Close;virtual;

    procedure DoStep(key:word);virtual;
    procedure DisposeDyn(p:pointer);virtual;
    procedure CopyDyn(Source,Target:pointer);virtual;
    procedure ChangeBounds(var Bounds:TRect);virtual;
    function  GetProperStep(st:word):integer;virtual;
    function  GetNumOfLines(st:word):byte;virtual;
  end;

implementation

uses Crt, Common, Dialogs, Views, App, MyApp;

const cmNewRule1a = 210;
      cmNewRule1b = 211;
      cmNewRule2a = 212;
      cmNewRule2b = 213;

type

  PDataRec = ^TDataRec;
  TDataRec = record
    Gramatika         : PGrammar;
    s1,
    PomPrav,
    NNet : PSet;
    i,j  : word;
  end;

  PView1Rec = ^TView1Rec;
  TView1Rec = object(TAlgView)
    blikej:boolean;
    pozice:word;
    constructor Init(var Bounds: TRect;AHScrollBar,AVScrollBar: PScrollBar);
    procedure Draw;virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
  end;

  PView2Rec = ^TView2Rec;
  TView2Rec = object(TAlgView)
    blikej:boolean;
    pozice:word;
    constructor Init(var Bounds: TRect;AHScrollBar,AVScrollBar: PScrollBar);
    procedure Draw;virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
  end;

  PViewNeterminal = ^TViewNeterminal;
  TViewNeterminal = object(TAlgView)
    procedure Draw;virtual;
  end;

  PViewProm = ^TViewProm;
  TViewProm = object(TAlgView)
    procedure Draw;virtual;
  end;

constructor TDemoRec.Init(g:PGrammar;ANumber:integer);
var Re:TRect;
    P:PView;
    L:PAlgTextCol;
    D:TDataRec;

begin
  Re.Assign(0,0,80,23);
  TAlgWindow.Init(Re,'Transformace na gramatiku bez lev rekurze',ANumber,
               MaxNumOfBackSteps,0,SizeOf(TDataRec),g);

  new(pom,Init);
  new(ProperList,Init);

  Terminal:=g^.Terminal;
  Neterminal:=g^.Neterminal;
  Pravidla:=g^.Pravidla;
  StartSym:=g^.StartSym;
  EpsChar:=g^.EpsChar;

  zobraz:=false;
  prav:=nil;
  zprac:=nil;

  with D do begin
    Gramatika:=g;
    NNet:=pom;
    PomPrav:=pom;
    s1:=pom;
    i:=0;
    j:=0;
  end;
  SetData(D);

  Re.Grow(-1,-1);
  Re.A.Y:=Re.B.Y-5;
  P:=new(PAlgText,Init(Re));
  L:=new(PAlgTextCol,Init(20,1));
  with L^ do begin
    AtInsert( 0,NewStr('1.  Nech je na vstupu vlastn gramatika a nech N = {A1, A2, ..., An} je'));
    AtInsert( 1,NewStr('    mnoina neterminl a Ai jsou jednotliv neterminly'));
    AtInsert( 2,NewStr('2.  Gramatiku transformujeme tak, e kdy Ai -->  je pravidlo, potom  mus'));
    AtInsert( 3,NewStr('    zanat bu terminlem t, nebo neterminlem Aj, j>i. Polome proto i:=1'));
    AtInsert( 4,NewStr('3.  Vytvome mnoinu vech pravidel Ai --> 1 | ... | p'));
    AtInsert( 5,NewStr('4.  Nyn odstranme nepmou rekurzi tchto pravidel a proto polome j:=1'));
    AtInsert( 6,NewStr('5.  Pokud plat j<i pejdeme na krok 6, jinak pejdeme na krok 8'));
    AtInsert( 7,NewStr('6.  Kad pravidlo Ai --> Aj nahradme pravidly Ai --> 1 | ... | q, kde'));
    AtInsert( 8,NewStr('    Aj --> 1 | ... | q jsou vechna (u transformovan) Aj-pravidla'));
    AtInsert( 9,NewStr('7.  Pak polome j:=j+1 a pejdeme na krok 5'));
    AtInsert(10,NewStr('8.  Nyn maj pravidla tvar Ai --> Ai1 | ... | Air | 1 | ... | t, kde'));
    AtInsert(11,NewStr('    dn i nezan neterminlem Ak, kdy k<=i'));
    AtInsert(12,NewStr('9.  Neexistuje-li pravidlo Ai --> Ai, pesuneme Ai-pravidla do nov mnoiny,'));
    AtInsert(13,NewStr('    jinak v nov mnoin nahradme vechna Ai-pravidla pravidly'));
    AtInsert(14,NewStr('       Ai   --> 1 | ... | t | 1<Ai''> | ... | t<Ai''>'));
    AtInsert(15,NewStr('      <Ai''> --> 1 | ... | r | 1<Ai''> | ... | r<Ai''>'));
    AtInsert(16,NewStr('10. Kdy i<n, provedeme i:=i+1 a pejdeme na krok 3,'));
    AtInsert(17,NewStr('    jinak je nov gramatika bez lev rekurze'));
  end;
  SetLastStep(17);
  PAlgText(P)^.NewList(L);
  InsertSubView(0,P);
  Re.Assign(1,1,29,17);
  P:=new(PView1Rec,Init(Re,nil,nil));
  InsertSubView(1,P);
  Re.Assign(50,1,79,17);
  P:=new(PView2Rec,Init(Re,nil,nil));
  InsertSubView(2,P);
  Re.Assign(30,1,49,4);
  P:=new(PViewStartSym,Init(Re,nil,nil));
  InsertSubView(3,P);
  Re.Assign(30,4,49,6);
  P:=new(PViewProm,Init(Re,nil,nil));
  InsertSubView(4,P);
  Re.Assign(30,6,49,17);
  P:=new(PViewNeterminal,Init(Re,nil,nil));
  InsertSubView(5,P);
end;

destructor TDemoRec.Done;
begin
  if ProperList<>nil then dispose(ProperList,Done);
  with PDataRec(DP)^ do
    if Gramatika<>nil then dispose(Gramatika,Done);
  if pom<>nil then dispose(pom,Done);
  TAlgWindow.Done;
end;

procedure TDemoRec.Close;
var k:PSet;
begin
  Message(Application,evBroadcast,cmBusy,nil);
  with PDataRec(DP)^ do begin
    if Step=17 then begin
      if NNet<>nil then NNet^.Sjednoceni(Gramatika^.Neterminal);
      k:=Gramatika^.Pravidla;
      Gramatika^.Pravidla:=PomPrav;
      PomPrav:=k;
      Gramatika^.SetState(_jeBezRekurze_);
      Gramatika^.ZrusNadbytecnaPravidla;
      Message(Application,evCommand,cmWriteGrammar,Gramatika);
    end;
  end;
  TAlgWindow.Close;
end;

procedure TDemoRec.DoStep(key:word);

procedure Nahrad(pr:PRuleSym);
var q:PRuleSym;
    ss:PSym;
    m:word;
begin
  if pr=nil then exit;
  with PDataRec(DP)^ do begin
    ss:=PSym(PRule(pr^.Pol)^.RemoveItem(1));
    m:=1;
    while (m<=PomPrav^.Num) and MemOk do begin
      if ss=PRule(PRuleSym(PomPrav^.GetItem(m))^.Pol)^.Head then begin
        Message(@Self,evBroadcast,cmNewRule2a,pointer(m));
	Wait(500);
        q:=PRuleSym(pr^.GetNewCopy);
        if q<>nil then begin
          PRule(q^.Pol)^.Insert(1,PExtRule(PRuleSym(PomPrav^.GetItem(m))^.Pol));
          with PRule(q^.Pol)^ do
            if (Num>1) or (Head<>PSym(List^.Item)) then begin
              s1^.MoveItem(s1^.Num+1,q);
              Message(@Self,evBroadcast,cmNewRule1a,pointer(s1^.Num));
            end else dispose(q,Done);
        end;
        Wait(500);
      end;
      inc(m);
    end;
    dispose(pr,Done);
  end;
end;

begin
  with PDataRec(DP)^ do
    case Step of
      0 : NS(1);
      1 : NS(2);
      2 : NS(3);
      3 : begin
            i:=1;
            NSM(4);
          end;
      4 : begin
            s:=PSym(Neterminal^.GetItem(i));
            y:=1;
            while (y<=Pravidla^.Num) and MemOk do begin
              if (PRule(Pravidla^.GetItem(y)^.Pol)^.Head=s) then begin
                Message(@Self,evBroadcast,cmNewRule1b,pointer(y));
                s1^.AddItem(s1^.Num+1,Pravidla^.GetItem(y));
                Message(@Self,evBroadcast,cmNewRule2b,pointer(s1^.Num));
              end;
              inc(y);
            end;
            {v s1 jsem vytvoril mnozinu pravidel zacinajich stejnym neterminalem}
            Message(@Self,evBroadcast,cmNewRule1a,pointer(0));
            Message(@Self,evBroadcast,cmNewRule2a,pointer(0));
            NSM(5);
          end;
      5 : begin
            j:=1;
            NSM(6);
          end;
      6 : if j<i then NS(7) else NS(10);
      7 : begin
            y:=1;
            while (y<=s1^.Num) and MemOk do begin
              s:=PSym(PRule(s1^.GetItem(y)^.Pol)^.List^.Item);
              if Neterminal^.IsInside(s) and
                 (s=PSym(Neterminal^.GetItem(j))) then begin
                Message(@Self,evBroadcast,cmNewRule1b,pointer(y));
                Wait(300);
                Nahrad(PRuleSym(s1^.GetItem(y)^.GetNewCopy));
                Message(@Self,evBroadcast,cmNewRule1b,pointer(y));
                Wait(300);
		s1^.DelItem(y);
                Message(@Self,evBroadcast,cmNewRule1a,pointer(0));
                Wait(500);
              end else inc(y);
            end;
            Message(@Self,evBroadcast,cmNewRule2a,pointer(0));
            Message(@Self,evBroadcast,cmNewRule1a,pointer(0));
            NSM(8);
          end;
      8 : NS(9);
      9 : begin
            inc(j);
            NSM(6);
          end;
     10 : NS(11);
     11 : NS(12);
     12 : begin
            y:=1;
            b:=false;
            h:=PSym(Neterminal^.GetItem(i));
            while (y<=s1^.Num) and not b do
              if PSym(PRule(s1^.GetItem(y)^.Pol)^.List^.Item)=h then b:=true
              else inc(y);
            {kontrola, zda obsahuje primou rekurzi }
            if not b then begin
              while s1^.Num>0 do begin
                Message(@Self,evBroadcast,cmNewRule1b,pointer(1));
                Message(@Self,evBroadcast,cmNewRule1a,pointer(0));
                PomPrav^.MoveItem(PomPrav^.Num+1,s1^.RemoveItem(1));
                Message(@Self,evBroadCast,cmNewRule2b,pointer(PomPrav^.Num));
              end;
              Message(@Self,evBroadCast,cmNewRule2a,pointer(0));
              Message(@Self,evBroadcast,cmNewRule1a,pointer(0));
              NSM(16);
            end else NS(13);
          end;
     13 : NS(14);
     14 : begin
            y:=1;
            while (y<=s1^.Num) and MemOk do begin
              zprac:=PRuleSym(s1^.GetItem(y));
              prav:=PRule(zprac^.Pol);
              s:=PSym(prav^.List^.Item);
              h:=prav^.Head;
              if h^.GetStr=start then
                h:=ProperList^.GetNewSym(StartSym,Neterminal,StartSym,EpsChar)
              else h:=ProperList^.GetNewSym(h,Neterminal,StartSym,EpsChar);
              if s<>prav^.Head then begin
                Message(@Self,evBroadcast,cmNewRule1a,pointer(y));
                PomPrav^.AddItem(PomPrav^.Num+1,zprac);
                Message(@Self,evBroadCast,cmNewRule2b,pointer(PomPrav^.Num));
                prav^.AddSym(h);
                PomPrav^.MoveItem(PomPrav^.Num+1,s1^.RemoveItem(y));
                Message(@Self,evBroadCast,cmNewRule2b,pointer(PomPrav^.Num));
              end else inc(y);
            end;
            Message(@Self,evBroadCast,cmNewRule2a,pointer(0));
            Message(@Self,evBroadcast,cmNewRule1a,pointer(0));
            NSM(15);
          end;
     15 : begin
            while (0<s1^.Num) and MemOk do begin
              zprac:=PRuleSym(s1^.GetItem(1)^.GetNewCopy);
              if zprac<>nil then begin
                prav:=PRule(zprac^.Pol);
                h:=prav^.Head;
                if h^.GetStr=start then
                  h:=ProperList^.GetNewSym(StartSym,Neterminal,StartSym,EpsChar)
                else h:=ProperList^.GetNewSym(h,Neterminal,StartSym,EpsChar);              prav^.Head:=h;
                Message(@Self,evBroadcast,cmNewRule1a,pointer(1));
                prav^.Head:=h;
                prav^.DelItem(1);
                PomPrav^.AddItem(PomPrav^.Num+1,zprac);
                Message(@Self,evBroadCast,cmNewRule2b,pointer(PomPrav^.Num));
                prav^.AddSym(h);
                PomPrav^.MoveItem(PomPrav^.Num+1,zprac);
                Message(@Self,evBroadCast,cmNewRule2b,pointer(PomPrav^.Num));
              end;
              s1^.DelItem(1);
            end;
            Message(@Self,evBroadCast,cmNewRule2a,pointer(0));
            Message(@Self,evBroadcast,cmNewRule1a,pointer(0));
            NSM(16);
          end;
     16 : if i<Neterminal^.Num then begin
            inc(i);
            NSM(4);
          end else begin
            y:=1;
            s:=ProperList^.GetOldNet(y);
            while (s<>nil) and MemOk do begin
              h:=ProperList^.GetNewNet(y);
              if h<>nil then
                NNet^.AddSym(h);
              inc(y);
              s:=ProperList^.GetOldNet(y);
            end;
            NSM(17);
          end;
     17 : ;
    end;
  TAlgWindow.DoStep(key);
end;

procedure TDemoRec.DisposeDyn(p:pointer);
begin
  with PDataRec(p)^ do begin
    if PomPrav<>nil then dispose(PomPrav,Done);
    if s1<>nil then dispose(s1,Done);
    if NNet<>nil then dispose(NNet,Done);
  end;
end;

procedure TDemoRec.CopyDyn(Source,Target:pointer);
begin
  with PDataRec(Source)^ do begin
    if PomPrav<>nil then
      PDataRec(Target)^.PomPrav:=PSet(PomPrav^.GetNewCopy);
    if NNet<>nil then
      PDataRec(Target)^.NNet:=PSet(NNet^.GetNewCopy);
    if s1<>nil then
      PDataRec(Target)^.s1:=PSet(s1^.GetNewCopy);
  end;
end;

procedure TDemoRec.ChangeBounds(var Bounds:TRect);
var Re:TRect;
    p,x,yy:integer;
begin
  Lock;
  x:=Bounds.B.X-Bounds.A.X;
  yy:=Bounds.B.Y-Bounds.A.Y;
  p:=yy*2 div 3+2;
  if yy-p<3 then
    if yy<7 then p:=yy-2
    else p:=yy-3;
  Re.Assign(1,p,x-1,yy-1);
  GetSubView(0)^.ChangeBounds(Re);
  yy:=p;
  p:=x div 3 + 3;
  if p>x div 2-1 then p:=x div 2-1;
  Re.Assign(1,1,p,yy);
  GetSubView(1)^.ChangeBounds(Re);
  Re.Assign(x-p-1,1,x-1,yy);
  GetSubView(2)^.ChangeBounds(Re);
  if (x-2*p-3>5) and (yy>=6) then zobraz:=true;
  if (x-2*p-3<5) or (yy<6) then zobraz:=false;
  Re.Assign(p+1,1,x-p-2,4);
  with GetSubView(3)^ do begin
    if zobraz then begin
      ChangeBounds(Re);
      Show;
    end else Hide;
  end;
  Re.Assign(p+1,4,x-p-2,6);
  with GetSubView(4)^ do begin
    if zobraz then begin
      ChangeBounds(Re);
      Show;
    end else Hide;
  end;
  Re.Assign(p+1,6,x-p-2,yy);
  with GetSubView(5)^ do begin
    if zobraz and (yy>8) then begin
      ChangeBounds(Re);
      Show;
    end else Hide;
  end;
  TAlgWin.ChangeBounds(Bounds);
  Unlock;
end;

function  TDemoRec.GetProperStep(st:word):integer;
const a:array[1..10] of byte = (0,2,4,5,6,7,9,10,12,16);
begin
  if (st<1) or (st>10) then GetProperStep:=-1
  else GetProperStep:=a[st];
end;

function  TDemoRec.GetNumOfLines(st:word):byte;
const a:array[1..10] of byte = (2,2,1,1,1,2,1,2,4,2);
begin
  if (st<1) or (st>10) then GetNumOfLines:=0
  else GetNumOfLines:=a[st];
end;

constructor TView1Rec.Init(var Bounds:TRect;AHScrollBar,AVScrollBar:PScrollBar);
begin
  TAlgView.Init(Bounds,AHScrollBar,AVScrollBar);
  blikej:=false;
  pozice:=0;
end;

procedure TView1Rec.Draw;
var p:byte;
begin
  with PDataRec(DP)^ do begin
    if First then begin
      Color:=GetColor(1);
      TAlgScroller.Draw;
      if Down then
        if Step in [0..4,16,17] then Frame('Pvodn gramatika',0)
        else Frame('Ai - pravidla',0)
      else
        if (Step=6)and(j=1) or (Step=4)and(i=1) or (Step in [0..3,5,17])
        then Frame('Pvodn gramatika',0)
        else Frame('Ai - pravidla',0);
    end else
      if Down then begin
        if Step in [0,16] then Frame('Pvodn gramatika',0)
        else if Step=5 then Frame('Ai - pravidla',0)
      end else
        if (Step=6)and(j=1) or (Step=5)
        then Frame('Pvodn gramatika',0)
        else if {(Step=4) and (i<>1) or} (Step=16)
             then Frame('Ai - pravidla',0);

    if blikej then p:=128 else p:=0;
    with Gramatika^ do
      if Down then
        if Step in [0..3,16,17] then
          Ukaz(Pravidla,0,0)
        else
          if Step=4 then
            if blikej then
              Ukaz(Pravidla,pozice,GetColor(2) or 128)
            else
              Ukaz(Pravidla,pozice,GetColor(2))
          else
            if Step in [7,12,14,15] then
              Ukaz(s1,pozice,GetColor(2) or p)
            else Ukaz(s1,0,0)
      else
        if (Step=6)and(j=1) or{ (Step=4)and(i=1) or} (Step in [0..5])
        then Ukaz(Pravidla,0,0)
        else Ukaz(s1,0,0);
  end;
end;

procedure TView1Rec.HandleEvent(var Event:TEvent);
begin
  TAlgView.HandleEvent(Event);
  if Event.What=evBroadCast then begin
    case Event.Command of
      cmNewRule1a : begin
          blikej:=false;
          pozice:=Event.InfoWord;
          DrawView;
          if pozice<>0 then Wait(400);
        end;
      cmNewRule1b : begin
          blikej:=true;
          pozice:=Event.InfoWord;
          DrawView;
          if pozice<>0 then Wait(500);
        end;
      else exit;
    end;
    ClearEvent(Event);
  end;
end;

constructor TView2Rec.Init(var Bounds:TRect;AHScrollBar,AVScrollBar:PScrollBar);
begin
  TAlgView.Init(Bounds,AHScrollBar,AVScrollBar);
  blikej:=false;
  pozice:=0;
end;

procedure TView2Rec.Draw;
var p:byte;
begin
  with PDataRec(DP)^ do begin
    if First then begin
      Color:=GetColor(1);
      TAlgScroller.Draw;
      if Down then
        if Step in [0..3,5..17] then Frame('Nov gramatika',0)
        else Frame('Ai - pravidla',0)
      else
        if (Step=6)and(j=1) or (Step=5) then Frame('Ai - pravidla',0)
        else Frame('Nov gramatika',0)
    end else
      if Down then begin
        if Step in [0,5] then Frame('Nov gramatika',0)
        else if (Step=3) or (Step=16)and(i<>j)
             then Frame('Ai - pravidla',0)
      end else
        if (Step=6)and(j=1) or (Step=5) then Frame('Ai - pravidla',0)
        else if Step in [3,16] then Frame('Nov gramatika',0);

    if blikej then p:=128 else p:=0;
    if Down then
      if Step in [7,12,14,15] then
        Ukaz(PomPrav,pozice,GetColor(2) or p)
      else
        if Step=4 then
          Ukaz(s1,pozice,GetColor(2) or p)
        else if (Step=3) or (Step=16)and(i<>j)
	     then Ukaz(s1,0,0)
             else Ukaz(PomPrav,0,0)
    else
      if (Step=6)and(j=1) or (Step in [4,5]) then Ukaz(s1,0,0)
      else Ukaz(PomPrav,0,0);
  end;
end;

procedure TView2Rec.HandleEvent(var Event:TEvent);
begin
  TAlgView.HandleEvent(Event);
  if Event.What=evBroadCast then begin
    case Event.Command of
      cmNewRule2a : begin
          blikej:=false;
          pozice:=Event.InfoWord;
          DrawView;
          if pozice<>0 then Wait(500);
        end;
      cmNewRule2b : begin
          blikej:=true;
          pozice:=Event.InfoWord;
          DrawView;
          if Pozice<>0 then Wait(500);
        end;
      else exit;
    end;
    ClearEvent(Event);
  end;
end;

procedure TViewNeterminal.Draw;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;

    Frame('Neterminly',1);
  end;

  with PDataRec(DP)^ do
    UkazSym(Gramatika^.Neterminal,i,GetColor(2));
end;

procedure TViewProm.Draw;
var s:string;
begin
  if First then begin
    Color:=GetColor(1);
    TAlgScroller.Draw;
  end;

  with PDataRec(DP)^ do begin
    str(i,s);
    if Size.X-6>=length(s) then
      WS(' i = '+s,0,0,Color)
    else
      WS(s,0,0,Color);
    str(j,s);
    if Size.X-6>=length(s) then
      WS(' j = '+s,0,1,Color)
    else
      WS(s,0,1,Color);
  end;
end;

end.