unit Rule;

interface

uses Pol,ListSet;

type

  PExtRule = ^TExtRule;
  TExtRule = object(TListSet)

                procedure AddSym(s:PPol);virtual;
                procedure DelSym(s:PPol);virtual;

                procedure Insert(n:word;r:PExtRule);virtual;
                procedure Delete(s,n:word);virtual;
                procedure Concat(r:PExtRule);virtual;
                procedure Nahrad(co,cim:PSym);virtual;
                function  GetPos(s:word;r:PExtRule):word;virtual;
                function  GetLeft(n:word):PExtRule;virtual;
                function  GetRight(n:word):PExtRule;virtual;
                function  GetMid(s,n:word):PExtRule;virtual;

                function  GetNew:PList;virtual;

              end;


  PRule = ^TRule;
  TRule = object(TExtRule)

             Head:PSym;

             constructor Init;
             destructor  Done;virtual;
             procedure   Reset;virtual;

             procedure SetHead(s:PSym);
             function  GetHead:PSym;
             procedure Nahrad(co,cim:PSym);virtual;

             function  GetMemory:longint;virtual;
             function  GetNew:PList;virtual;
             procedure GetCopy(o:PList);virtual;

           end;


  PRuleSym = ^TRuleSym;
  TRuleSym = object(TPol)

                constructor Init;
                destructor  Done;virtual;
                procedure   Reset;virtual;

                procedure InitSetStr;virtual;
                procedure InitGetStr;virtual;
                procedure SetStr(s:PPol);virtual;
                function  GetStr:string;virtual;
                function  GetLength:word;virtual;

                function  Equal(o:PPol):boolean;virtual;
                function  NotEqual(o:PPol):boolean;virtual;
                function  Vetsi(o:PPol):boolean;virtual;
                function  Mensi(o:PPol):boolean;virtual;

                function  GetMemory:longint;virtual;
                function  GetNew:PPol;virtual;
                procedure GetCopy(o:PPol);virtual;

              private

                n,m:byte;

              end;

implementation

uses Common;


{##########################  Metody TExtRule  ############################}

procedure TExtRule.AddSym(s:PPol);
begin
  AddItem(Num+1,s);
end;

procedure TExtRule.DelSym(s:PPol);
var n:word;
    p:PItem;
begin
  if s<>nil then begin
    n:=1;
    p:=List;
    while n<=Num do begin
      if s^.Equal(p^.Item) then DelItem(n)
      else begin
        p:=p^.next;
        inc(n);
      end;
    end;
  end;
end;

procedure TExtRule.Insert(n:word;r:PExtRule);
var i:word;
begin
  if (r<>nil) and (n>0) then begin
    i:=1;
    while (i<=r^.Num) and MemOk do begin
      AddItem(n+i-1,r^.GetItem(i));
      inc(i);
    end;
  end;
end;

procedure TExtRule.Delete(s,n:word);
var i:word;
begin
  if (s>0) and (n>0) then
    for i:=s to s+n-1 do DelItem(s);
end;

procedure TExtRule.Concat(r:PExtRule);
var i:word;
begin
  if r<>nil then begin
    i:=1;
    while (i<=r^.Num) and MemOk do begin
      AddItem(Num+1,r^.GetItem(i));
      inc(i);
    end;
  end;
end;

procedure TExtRule.Nahrad(co,cim:PSym);
var n:word;
begin
  n:=GetPosSym(1,co);
  while n<>0 do begin
    SetItem(n,cim);
    n:=GetPosSym(n+1,co);
  end;
end;

function  TExtRule.GetPos(s:word;r:PExtRule):word;
var i,n:word;
    b:boolean;
begin
  b:=false;
  if r<>nil then begin
    n:=r^.Num;
    while not(b) and (s+n-1<=Num) do begin
      b:=true;
      i:=1;
      while b and (i<=n) do
        if GetItem(s+i-1)^.Equal(r^.GetItem(i)) then inc(i)
        else begin b:=false;inc(s);end;
    end;
  end;
  if b then GetPos:=s
       else GetPos:=0;
end;

function  TExtRule.GetLeft(n:word):PExtRule;
var p:PExtRule;
    i:word;
begin
  if n>0 then begin
    p:=PExtRule(GetNew);
    if p<>nil then begin
      if n>Num then n:=Num;
      i:=1;
      while (i<=n) and MemOk do begin
        p^.AddItem(i,GetItem(i));
        inc(i);
      end;
      GetLeft:=p;
      exit;
    end;
  end;
  GetLeft:=nil;
end;

function  TExtRule.GetRight(n:word):PExtRule;
var p:PExtRule;
    i:word;
begin
  if n>0 then begin
    p:=PExtRule(GetNew);
    if p<>nil then begin
      if n>Num then n:=Num;
      i:=1;
      while (i<=n) and MemOk do begin
        p^.AddItem(i,GetItem(i+Num-n));
        inc(i);
      end;
      GetRight:=p;
      exit;
    end;
  end;
  GetRight:=nil;
end;

function  TExtRule.GetMid(s,n:word):PExtRule;
var p:PExtRule;
    i:word;
begin
  if (s>0) and (n>0) then begin
    p:=PExtRule(GetNew);
    if p<>nil then begin
      if s>Num then n:=0 else
        if s+n-1>Num then n:=Num-s+1;
      i:=1;
      while (i<=n) and MemOk do begin
        p^.AddItem(i,GetItem(s+i-1));
        inc(i);
      end;
      GetMid:=p;
      exit;
    end;
  end;
  GetMid:=nil;
end;

function  TExtRule.GetNew:PList;
begin
  GetNew:=new(PExtRule,Init);
end;



{###########################  Metody TRule  ##########################}

constructor TRule.Init;
begin
  if not(TExtRule.Init) then Fail;
  Head:=Sym('');
end;

destructor TRule.Done;
begin
  TExtRule.Done;
end;

procedure TRule.Reset;
begin
  TExtRule.Reset;
  Head:=Sym('');
end;

procedure TRule.SetHead(s:PSym);
begin
  if s<>nil then Head:=s;
end;

function  TRule.GetHead:PSym;
begin
  GetHead:=Head;
end;

procedure TRule.Nahrad(co,cim:PSym);
begin
  TExtRule.Nahrad(co,cim);
  if co^.Equal(Head) then Head:=cim;
end;

function TRule.GetMemory:longint;
begin
  GetMemory:=TExtRule.GetMemory+SizeOf(Head);
end;

function  TRule.GetNew:PList;
begin
  GetNew:=new(PRule,Init);
end;

procedure TRule.GetCopy(o:PList);
begin
  if o<>nil then begin
    TExtRule.GetCopy(o);
    if MemOk then PRule(o)^.Head:=Head;
  end;
end;



{##########################  Metody TRuleSym  ###########################}

constructor TRuleSym.Init;
var r:PRule;
begin
  if not(TPol.Init) then Fail;
  new(r,Init);
  if r=nil then Fail;
  m:=0;n:=0;pol:=r;
end;

destructor  TRuleSym.Done;
var r:PRule;
begin
  r:=Pol;
  if r<>nil then dispose(r,Done);
  TPol.Done;
end;

procedure TRuleSym.Reset;
begin
  PRule(pol)^.Reset;
  m:=0;n:=0;
end;

procedure TRuleSym.InitSetStr;
begin
  Reset;
end;

procedure TRuleSym.InitGetStr;
begin
  m:=0;
end;

procedure TRuleSym.SetStr(s:PPol);
begin
  if (s<>nil) and MemOk then
    with PRule(Pol)^ do
      case n of
        0 : begin
              Head:=PSym(s);
              n:=1;
            end;
        1 : AddSym(s);
      end;
end;

function  TRuleSym.GetStr:string;
begin
  with PRule(Pol)^ do
    if m>Num then GetStr:=''
    else begin
      if m=0 then GetStr:=Head^.GetStr
      else GetStr:=GetItem(m)^.GetStr;
      inc(m);
    end;
end;

function  TRuleSym.GetLength:word;
var x,y:word;
    p:PItem;
begin
  x:=0;
  if Pol<>nil then
    with PRule(Pol)^ do begin
      p:=List;
      for y:=1 to Num do begin
        inc(x,p^.Item^.GetLength);
        p:=p^.next;
      end;
      inc(x,Head^.GetLength);
    end;
  GetLength:=x;
end;

function  TRuleSym.Equal(o:PPol):boolean;
var s,r:string;
begin
  if o=nil then Equal:=false
  else if o^.Pol=Pol then Equal:=true
  else begin
    InitGetStr;
    o^.InitGetStr;
    repeat
      r:=GetStr;
      s:=o^.GetStr;
    until (r<>s) or (r='') or (s='');
    Equal:=r=s;
  end;
end;

function  TRuleSym.NotEqual(o:PPol):boolean;
begin
  NotEqual:=not(Equal(o));
end;

function  TRuleSym.Vetsi(o:PPol):boolean;
begin
  if o=nil then Vetsi:=true
  else Vetsi:=PRule(Pol)^.Head^.GetStr>PRule(o^.Pol)^.Head^.GetStr;
end;

function  TRuleSym.Mensi(o:PPol):boolean;
begin
  if o=nil then Mensi:=false
  else Mensi:=PRule(Pol)^.Head^.GetStr<PRule(o^.Pol)^.Head^.GetStr;
end;

function  TRuleSym.GetMemory:longint;
var i:longint;
begin
  i:=SizeOf(TRuleSym);
  if Pol<>nil then inc(i,PRule(Pol)^.GetMemory);
  GetMemory:=i;
end;

function  TRuleSym.GetNew:PPol;
begin
  GetNew:=new(PRuleSym,Init);
end;

procedure TRuleSym.GetCopy(o:PPol);
var s:string;
begin
  if (o<>nil) and (Pol<>nil) then
    PRule(Pol)^.GetCopy(PRule(o^.Pol));
end;

end.

